// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_platform_msgs:msg/AdaptiveCruiseControlCommand.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__ADAPTIVE_CRUISE_CONTROL_COMMAND__STRUCT_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__ADAPTIVE_CRUISE_CONTROL_COMMAND__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_platform_msgs__msg__AdaptiveCruiseControlCommand __attribute__((deprecated))
#else
# define DEPRECATED__automotive_platform_msgs__msg__AdaptiveCruiseControlCommand __declspec(deprecated)
#endif

namespace automotive_platform_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AdaptiveCruiseControlCommand_
{
  using Type = AdaptiveCruiseControlCommand_<ContainerAllocator>;

  explicit AdaptiveCruiseControlCommand_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->msg_counter = 0;
      this->set_speed = 0.0f;
      this->set = 0;
      this->resume = 0;
      this->cancel = 0;
      this->speed_up = 0;
      this->slow_down = 0;
      this->further = 0;
      this->closer = 0;
    }
  }

  explicit AdaptiveCruiseControlCommand_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->msg_counter = 0;
      this->set_speed = 0.0f;
      this->set = 0;
      this->resume = 0;
      this->cancel = 0;
      this->speed_up = 0;
      this->slow_down = 0;
      this->further = 0;
      this->closer = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _msg_counter_type =
    uint8_t;
  _msg_counter_type msg_counter;
  using _set_speed_type =
    float;
  _set_speed_type set_speed;
  using _set_type =
    uint16_t;
  _set_type set;
  using _resume_type =
    uint16_t;
  _resume_type resume;
  using _cancel_type =
    uint16_t;
  _cancel_type cancel;
  using _speed_up_type =
    uint16_t;
  _speed_up_type speed_up;
  using _slow_down_type =
    uint16_t;
  _slow_down_type slow_down;
  using _further_type =
    uint16_t;
  _further_type further;
  using _closer_type =
    uint16_t;
  _closer_type closer;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__msg_counter(
    const uint8_t & _arg)
  {
    this->msg_counter = _arg;
    return *this;
  }
  Type & set__set_speed(
    const float & _arg)
  {
    this->set_speed = _arg;
    return *this;
  }
  Type & set__set(
    const uint16_t & _arg)
  {
    this->set = _arg;
    return *this;
  }
  Type & set__resume(
    const uint16_t & _arg)
  {
    this->resume = _arg;
    return *this;
  }
  Type & set__cancel(
    const uint16_t & _arg)
  {
    this->cancel = _arg;
    return *this;
  }
  Type & set__speed_up(
    const uint16_t & _arg)
  {
    this->speed_up = _arg;
    return *this;
  }
  Type & set__slow_down(
    const uint16_t & _arg)
  {
    this->slow_down = _arg;
    return *this;
  }
  Type & set__further(
    const uint16_t & _arg)
  {
    this->further = _arg;
    return *this;
  }
  Type & set__closer(
    const uint16_t & _arg)
  {
    this->closer = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_platform_msgs::msg::AdaptiveCruiseControlCommand_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_platform_msgs::msg::AdaptiveCruiseControlCommand_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlCommand_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlCommand_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::AdaptiveCruiseControlCommand_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlCommand_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::AdaptiveCruiseControlCommand_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlCommand_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlCommand_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlCommand_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_platform_msgs__msg__AdaptiveCruiseControlCommand
    std::shared_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlCommand_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_platform_msgs__msg__AdaptiveCruiseControlCommand
    std::shared_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlCommand_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AdaptiveCruiseControlCommand_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->msg_counter != other.msg_counter) {
      return false;
    }
    if (this->set_speed != other.set_speed) {
      return false;
    }
    if (this->set != other.set) {
      return false;
    }
    if (this->resume != other.resume) {
      return false;
    }
    if (this->cancel != other.cancel) {
      return false;
    }
    if (this->speed_up != other.speed_up) {
      return false;
    }
    if (this->slow_down != other.slow_down) {
      return false;
    }
    if (this->further != other.further) {
      return false;
    }
    if (this->closer != other.closer) {
      return false;
    }
    return true;
  }
  bool operator!=(const AdaptiveCruiseControlCommand_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AdaptiveCruiseControlCommand_

// alias to use template instance with default allocator
using AdaptiveCruiseControlCommand =
  automotive_platform_msgs::msg::AdaptiveCruiseControlCommand_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_platform_msgs

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__ADAPTIVE_CRUISE_CONTROL_COMMAND__STRUCT_HPP_
