// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_platform_msgs:msg/AdaptiveCruiseControlSettings.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__ADAPTIVE_CRUISE_CONTROL_SETTINGS__STRUCT_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__ADAPTIVE_CRUISE_CONTROL_SETTINGS__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_platform_msgs__msg__AdaptiveCruiseControlSettings __attribute__((deprecated))
#else
# define DEPRECATED__automotive_platform_msgs__msg__AdaptiveCruiseControlSettings __declspec(deprecated)
#endif

namespace automotive_platform_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AdaptiveCruiseControlSettings_
{
  using Type = AdaptiveCruiseControlSettings_<ContainerAllocator>;

  explicit AdaptiveCruiseControlSettings_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->set_speed = 0.0f;
      this->following_spot = 0;
      this->min_percent = 0.0f;
      this->step_percent = 0.0f;
      this->cipv_percent = 0.0f;
      this->max_distance = 0.0f;
    }
  }

  explicit AdaptiveCruiseControlSettings_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->set_speed = 0.0f;
      this->following_spot = 0;
      this->min_percent = 0.0f;
      this->step_percent = 0.0f;
      this->cipv_percent = 0.0f;
      this->max_distance = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _set_speed_type =
    float;
  _set_speed_type set_speed;
  using _following_spot_type =
    uint16_t;
  _following_spot_type following_spot;
  using _min_percent_type =
    float;
  _min_percent_type min_percent;
  using _step_percent_type =
    float;
  _step_percent_type step_percent;
  using _cipv_percent_type =
    float;
  _cipv_percent_type cipv_percent;
  using _max_distance_type =
    float;
  _max_distance_type max_distance;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__set_speed(
    const float & _arg)
  {
    this->set_speed = _arg;
    return *this;
  }
  Type & set__following_spot(
    const uint16_t & _arg)
  {
    this->following_spot = _arg;
    return *this;
  }
  Type & set__min_percent(
    const float & _arg)
  {
    this->min_percent = _arg;
    return *this;
  }
  Type & set__step_percent(
    const float & _arg)
  {
    this->step_percent = _arg;
    return *this;
  }
  Type & set__cipv_percent(
    const float & _arg)
  {
    this->cipv_percent = _arg;
    return *this;
  }
  Type & set__max_distance(
    const float & _arg)
  {
    this->max_distance = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_platform_msgs::msg::AdaptiveCruiseControlSettings_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_platform_msgs::msg::AdaptiveCruiseControlSettings_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlSettings_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlSettings_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::AdaptiveCruiseControlSettings_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlSettings_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::AdaptiveCruiseControlSettings_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlSettings_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlSettings_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlSettings_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_platform_msgs__msg__AdaptiveCruiseControlSettings
    std::shared_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlSettings_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_platform_msgs__msg__AdaptiveCruiseControlSettings
    std::shared_ptr<automotive_platform_msgs::msg::AdaptiveCruiseControlSettings_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AdaptiveCruiseControlSettings_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->set_speed != other.set_speed) {
      return false;
    }
    if (this->following_spot != other.following_spot) {
      return false;
    }
    if (this->min_percent != other.min_percent) {
      return false;
    }
    if (this->step_percent != other.step_percent) {
      return false;
    }
    if (this->cipv_percent != other.cipv_percent) {
      return false;
    }
    if (this->max_distance != other.max_distance) {
      return false;
    }
    return true;
  }
  bool operator!=(const AdaptiveCruiseControlSettings_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AdaptiveCruiseControlSettings_

// alias to use template instance with default allocator
using AdaptiveCruiseControlSettings =
  automotive_platform_msgs::msg::AdaptiveCruiseControlSettings_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_platform_msgs

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__ADAPTIVE_CRUISE_CONTROL_SETTINGS__STRUCT_HPP_
