#ifndef _H_1E83376F467DFEDD4F6AB10E4C20AF77_AdaptiveCruiseControlCommand__H_
#define _H_1E83376F467DFEDD4F6AB10E4C20AF77_AdaptiveCruiseControlCommand__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  AdaptiveCruiseControlCommand_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet msg_counter_;
                ::DDS::Float set_speed_;
                ::DDS::UShort set_;
                ::DDS::UShort resume_;
                ::DDS::UShort cancel_;
                ::DDS::UShort speed_up_;
                ::DDS::UShort slow_down_;
                ::DDS::UShort further_;
                ::DDS::UShort closer_;
            };

            typedef DDS_DCPSStruct_var<AdaptiveCruiseControlCommand_> AdaptiveCruiseControlCommand__var;
            typedef DDS_DCPSStruct_out < AdaptiveCruiseControlCommand_> AdaptiveCruiseControlCommand__out;

        }

    }

}

#endif /* _H_1E83376F467DFEDD4F6AB10E4C20AF77_AdaptiveCruiseControlCommand__H_ */
