#ifndef _H_6462DA963F7072D51FFFDED3D99405B2_AdaptiveCruiseControlSettings__H_
#define _H_6462DA963F7072D51FFFDED3D99405B2_AdaptiveCruiseControlSettings__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  AdaptiveCruiseControlSettings_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Float set_speed_;
                ::DDS::UShort following_spot_;
                ::DDS::Float min_percent_;
                ::DDS::Float step_percent_;
                ::DDS::Float cipv_percent_;
                ::DDS::Float max_distance_;
            };

            typedef DDS_DCPSStruct_var<AdaptiveCruiseControlSettings_> AdaptiveCruiseControlSettings__var;
            typedef DDS_DCPSStruct_out < AdaptiveCruiseControlSettings_> AdaptiveCruiseControlSettings__out;

        }

    }

}

#endif /* _H_6462DA963F7072D51FFFDED3D99405B2_AdaptiveCruiseControlSettings__H_ */
