#ifndef _H_6462DA963F7072D51FFFDED3D99405B2_AdaptiveCruiseControlSettings_DCPS_H_
#define _H_6462DA963F7072D51FFFDED3D99405B2_AdaptiveCruiseControlSettings_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AdaptiveCruiseControlSettings_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class AdaptiveCruiseControlSettings_TypeSupportInterface;

            typedef AdaptiveCruiseControlSettings_TypeSupportInterface * AdaptiveCruiseControlSettings_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AdaptiveCruiseControlSettings_TypeSupportInterface> AdaptiveCruiseControlSettings_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AdaptiveCruiseControlSettings_TypeSupportInterface> AdaptiveCruiseControlSettings_TypeSupportInterface_out;


            class AdaptiveCruiseControlSettings_DataWriter;

            typedef AdaptiveCruiseControlSettings_DataWriter * AdaptiveCruiseControlSettings_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AdaptiveCruiseControlSettings_DataWriter> AdaptiveCruiseControlSettings_DataWriter_var;
            typedef DDS_DCPSInterface_out < AdaptiveCruiseControlSettings_DataWriter> AdaptiveCruiseControlSettings_DataWriter_out;


            class AdaptiveCruiseControlSettings_DataReader;

            typedef AdaptiveCruiseControlSettings_DataReader * AdaptiveCruiseControlSettings_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AdaptiveCruiseControlSettings_DataReader> AdaptiveCruiseControlSettings_DataReader_var;
            typedef DDS_DCPSInterface_out < AdaptiveCruiseControlSettings_DataReader> AdaptiveCruiseControlSettings_DataReader_out;


            class AdaptiveCruiseControlSettings_DataReaderView;

            typedef AdaptiveCruiseControlSettings_DataReaderView * AdaptiveCruiseControlSettings_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AdaptiveCruiseControlSettings_DataReaderView> AdaptiveCruiseControlSettings_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AdaptiveCruiseControlSettings_DataReaderView> AdaptiveCruiseControlSettings_DataReaderView_out;

            struct AdaptiveCruiseControlSettings_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AdaptiveCruiseControlSettings_, struct AdaptiveCruiseControlSettings_Seq_uniq_> AdaptiveCruiseControlSettings_Seq;
            typedef DDS_DCPSSequence_var < AdaptiveCruiseControlSettings_Seq> AdaptiveCruiseControlSettings_Seq_var;
            typedef DDS_DCPSSequence_out < AdaptiveCruiseControlSettings_Seq> AdaptiveCruiseControlSettings_Seq_out;

            class  AdaptiveCruiseControlSettings_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AdaptiveCruiseControlSettings_TypeSupportInterface_ptr _ptr_type;
                typedef AdaptiveCruiseControlSettings_TypeSupportInterface_var _var_type;

                static AdaptiveCruiseControlSettings_TypeSupportInterface_ptr _duplicate (AdaptiveCruiseControlSettings_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AdaptiveCruiseControlSettings_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlSettings_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlSettings_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AdaptiveCruiseControlSettings_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AdaptiveCruiseControlSettings_TypeSupportInterface () {};
                ~AdaptiveCruiseControlSettings_TypeSupportInterface () {};
            private:
                AdaptiveCruiseControlSettings_TypeSupportInterface (const AdaptiveCruiseControlSettings_TypeSupportInterface &);
                AdaptiveCruiseControlSettings_TypeSupportInterface & operator = (const AdaptiveCruiseControlSettings_TypeSupportInterface &);
            };

            class  AdaptiveCruiseControlSettings_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AdaptiveCruiseControlSettings_DataWriter_ptr _ptr_type;
                typedef AdaptiveCruiseControlSettings_DataWriter_var _var_type;

                static AdaptiveCruiseControlSettings_DataWriter_ptr _duplicate (AdaptiveCruiseControlSettings_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AdaptiveCruiseControlSettings_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlSettings_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlSettings_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AdaptiveCruiseControlSettings_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AdaptiveCruiseControlSettings_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AdaptiveCruiseControlSettings_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AdaptiveCruiseControlSettings_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AdaptiveCruiseControlSettings_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AdaptiveCruiseControlSettings_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AdaptiveCruiseControlSettings_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AdaptiveCruiseControlSettings_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AdaptiveCruiseControlSettings_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AdaptiveCruiseControlSettings_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AdaptiveCruiseControlSettings_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AdaptiveCruiseControlSettings_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AdaptiveCruiseControlSettings_& instance_data) = 0;

            protected:
                AdaptiveCruiseControlSettings_DataWriter () {};
                ~AdaptiveCruiseControlSettings_DataWriter () {};
            private:
                AdaptiveCruiseControlSettings_DataWriter (const AdaptiveCruiseControlSettings_DataWriter &);
                AdaptiveCruiseControlSettings_DataWriter & operator = (const AdaptiveCruiseControlSettings_DataWriter &);
            };

            class  AdaptiveCruiseControlSettings_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AdaptiveCruiseControlSettings_DataReader_ptr _ptr_type;
                typedef AdaptiveCruiseControlSettings_DataReader_var _var_type;

                static AdaptiveCruiseControlSettings_DataReader_ptr _duplicate (AdaptiveCruiseControlSettings_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AdaptiveCruiseControlSettings_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlSettings_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlSettings_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AdaptiveCruiseControlSettings_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AdaptiveCruiseControlSettings_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AdaptiveCruiseControlSettings_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AdaptiveCruiseControlSettings_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AdaptiveCruiseControlSettings_& instance) = 0;

            protected:
                AdaptiveCruiseControlSettings_DataReader () {};
                ~AdaptiveCruiseControlSettings_DataReader () {};
            private:
                AdaptiveCruiseControlSettings_DataReader (const AdaptiveCruiseControlSettings_DataReader &);
                AdaptiveCruiseControlSettings_DataReader & operator = (const AdaptiveCruiseControlSettings_DataReader &);
            };

            class  AdaptiveCruiseControlSettings_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AdaptiveCruiseControlSettings_DataReaderView_ptr _ptr_type;
                typedef AdaptiveCruiseControlSettings_DataReaderView_var _var_type;

                static AdaptiveCruiseControlSettings_DataReaderView_ptr _duplicate (AdaptiveCruiseControlSettings_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AdaptiveCruiseControlSettings_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlSettings_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlSettings_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AdaptiveCruiseControlSettings_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AdaptiveCruiseControlSettings_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AdaptiveCruiseControlSettings_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AdaptiveCruiseControlSettings_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AdaptiveCruiseControlSettings_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AdaptiveCruiseControlSettings_& instance) = 0;

            protected:
                AdaptiveCruiseControlSettings_DataReaderView () {};
                ~AdaptiveCruiseControlSettings_DataReaderView () {};
            private:
                AdaptiveCruiseControlSettings_DataReaderView (const AdaptiveCruiseControlSettings_DataReaderView &);
                AdaptiveCruiseControlSettings_DataReaderView & operator = (const AdaptiveCruiseControlSettings_DataReaderView &);
            };
        }

    }

}

#endif
