#ifndef _H_1D09ACED94452F462D50F13FA639E50E_CabinReport__H_
#define _H_1D09ACED94452F462D50F13FA639E50E_CabinReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  CabinReport_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean door_open_front_right_;
                ::DDS::Boolean door_open_front_left_;
                ::DDS::Boolean door_open_rear_right_;
                ::DDS::Boolean door_open_rear_left_;
                ::DDS::Boolean hood_open_;
                ::DDS::Boolean trunk_open_;
                ::DDS::Boolean passenger_present_;
                ::DDS::Boolean passenger_airbag_enabled_;
                ::DDS::Boolean seatbelt_engaged_driver_;
                ::DDS::Boolean seatbelt_engaged_passenger_;
            };

            typedef DDS_DCPSStruct_var<CabinReport_> CabinReport__var;
            typedef DDS_DCPSStruct_out < CabinReport_> CabinReport__out;

        }

    }

}

#endif /* _H_1D09ACED94452F462D50F13FA639E50E_CabinReport__H_ */
