#ifndef _H_1D09ACED94452F462D50F13FA639E50E_CabinReport_DCPS_H_
#define _H_1D09ACED94452F462D50F13FA639E50E_CabinReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CabinReport_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class CabinReport_TypeSupportInterface;

            typedef CabinReport_TypeSupportInterface * CabinReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CabinReport_TypeSupportInterface> CabinReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CabinReport_TypeSupportInterface> CabinReport_TypeSupportInterface_out;


            class CabinReport_DataWriter;

            typedef CabinReport_DataWriter * CabinReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CabinReport_DataWriter> CabinReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < CabinReport_DataWriter> CabinReport_DataWriter_out;


            class CabinReport_DataReader;

            typedef CabinReport_DataReader * CabinReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CabinReport_DataReader> CabinReport_DataReader_var;
            typedef DDS_DCPSInterface_out < CabinReport_DataReader> CabinReport_DataReader_out;


            class CabinReport_DataReaderView;

            typedef CabinReport_DataReaderView * CabinReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CabinReport_DataReaderView> CabinReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CabinReport_DataReaderView> CabinReport_DataReaderView_out;

            struct CabinReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < CabinReport_, struct CabinReport_Seq_uniq_> CabinReport_Seq;
            typedef DDS_DCPSSequence_var < CabinReport_Seq> CabinReport_Seq_var;
            typedef DDS_DCPSSequence_out < CabinReport_Seq> CabinReport_Seq_out;

            class  CabinReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CabinReport_TypeSupportInterface_ptr _ptr_type;
                typedef CabinReport_TypeSupportInterface_var _var_type;

                static CabinReport_TypeSupportInterface_ptr _duplicate (CabinReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CabinReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CabinReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CabinReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CabinReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CabinReport_TypeSupportInterface () {};
                ~CabinReport_TypeSupportInterface () {};
            private:
                CabinReport_TypeSupportInterface (const CabinReport_TypeSupportInterface &);
                CabinReport_TypeSupportInterface & operator = (const CabinReport_TypeSupportInterface &);
            };

            class  CabinReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CabinReport_DataWriter_ptr _ptr_type;
                typedef CabinReport_DataWriter_var _var_type;

                static CabinReport_DataWriter_ptr _duplicate (CabinReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CabinReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CabinReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CabinReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CabinReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CabinReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CabinReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CabinReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CabinReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CabinReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CabinReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CabinReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CabinReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CabinReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CabinReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CabinReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CabinReport_& instance_data) = 0;

            protected:
                CabinReport_DataWriter () {};
                ~CabinReport_DataWriter () {};
            private:
                CabinReport_DataWriter (const CabinReport_DataWriter &);
                CabinReport_DataWriter & operator = (const CabinReport_DataWriter &);
            };

            class  CabinReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CabinReport_DataReader_ptr _ptr_type;
                typedef CabinReport_DataReader_var _var_type;

                static CabinReport_DataReader_ptr _duplicate (CabinReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CabinReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CabinReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CabinReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CabinReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CabinReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CabinReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CabinReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CabinReport_& instance) = 0;

            protected:
                CabinReport_DataReader () {};
                ~CabinReport_DataReader () {};
            private:
                CabinReport_DataReader (const CabinReport_DataReader &);
                CabinReport_DataReader & operator = (const CabinReport_DataReader &);
            };

            class  CabinReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CabinReport_DataReaderView_ptr _ptr_type;
                typedef CabinReport_DataReaderView_var _var_type;

                static CabinReport_DataReaderView_ptr _duplicate (CabinReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CabinReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CabinReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CabinReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CabinReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CabinReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CabinReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CabinReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CabinReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CabinReport_& instance) = 0;

            protected:
                CabinReport_DataReaderView () {};
                ~CabinReport_DataReaderView () {};
            private:
                CabinReport_DataReaderView (const CabinReport_DataReaderView &);
                CabinReport_DataReaderView & operator = (const CabinReport_DataReaderView &);
            };
        }

    }

}

#endif
