#ifndef _H_4830E4918F045AB5C6D92059D8ADBED5_GearFeedback_DCPS_H_
#define _H_4830E4918F045AB5C6D92059D8ADBED5_GearFeedback_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GearFeedback_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GearFeedback_TypeSupportInterface;

            typedef GearFeedback_TypeSupportInterface * GearFeedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GearFeedback_TypeSupportInterface> GearFeedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GearFeedback_TypeSupportInterface> GearFeedback_TypeSupportInterface_out;


            class GearFeedback_DataWriter;

            typedef GearFeedback_DataWriter * GearFeedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GearFeedback_DataWriter> GearFeedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < GearFeedback_DataWriter> GearFeedback_DataWriter_out;


            class GearFeedback_DataReader;

            typedef GearFeedback_DataReader * GearFeedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GearFeedback_DataReader> GearFeedback_DataReader_var;
            typedef DDS_DCPSInterface_out < GearFeedback_DataReader> GearFeedback_DataReader_out;


            class GearFeedback_DataReaderView;

            typedef GearFeedback_DataReaderView * GearFeedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GearFeedback_DataReaderView> GearFeedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GearFeedback_DataReaderView> GearFeedback_DataReaderView_out;

            struct GearFeedback_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GearFeedback_, struct GearFeedback_Seq_uniq_> GearFeedback_Seq;
            typedef DDS_DCPSSequence_var < GearFeedback_Seq> GearFeedback_Seq_var;
            typedef DDS_DCPSSequence_out < GearFeedback_Seq> GearFeedback_Seq_out;

            class  GearFeedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GearFeedback_TypeSupportInterface_ptr _ptr_type;
                typedef GearFeedback_TypeSupportInterface_var _var_type;

                static GearFeedback_TypeSupportInterface_ptr _duplicate (GearFeedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GearFeedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GearFeedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GearFeedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GearFeedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GearFeedback_TypeSupportInterface () {};
                ~GearFeedback_TypeSupportInterface () {};
            private:
                GearFeedback_TypeSupportInterface (const GearFeedback_TypeSupportInterface &);
                GearFeedback_TypeSupportInterface & operator = (const GearFeedback_TypeSupportInterface &);
            };

            class  GearFeedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GearFeedback_DataWriter_ptr _ptr_type;
                typedef GearFeedback_DataWriter_var _var_type;

                static GearFeedback_DataWriter_ptr _duplicate (GearFeedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GearFeedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GearFeedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GearFeedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GearFeedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GearFeedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GearFeedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GearFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GearFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GearFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GearFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GearFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GearFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GearFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GearFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GearFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GearFeedback_& instance_data) = 0;

            protected:
                GearFeedback_DataWriter () {};
                ~GearFeedback_DataWriter () {};
            private:
                GearFeedback_DataWriter (const GearFeedback_DataWriter &);
                GearFeedback_DataWriter & operator = (const GearFeedback_DataWriter &);
            };

            class  GearFeedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GearFeedback_DataReader_ptr _ptr_type;
                typedef GearFeedback_DataReader_var _var_type;

                static GearFeedback_DataReader_ptr _duplicate (GearFeedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GearFeedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GearFeedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GearFeedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GearFeedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GearFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GearFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GearFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GearFeedback_& instance) = 0;

            protected:
                GearFeedback_DataReader () {};
                ~GearFeedback_DataReader () {};
            private:
                GearFeedback_DataReader (const GearFeedback_DataReader &);
                GearFeedback_DataReader & operator = (const GearFeedback_DataReader &);
            };

            class  GearFeedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GearFeedback_DataReaderView_ptr _ptr_type;
                typedef GearFeedback_DataReaderView_var _var_type;

                static GearFeedback_DataReaderView_ptr _duplicate (GearFeedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GearFeedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GearFeedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GearFeedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GearFeedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GearFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GearFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GearFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GearFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GearFeedback_& instance) = 0;

            protected:
                GearFeedback_DataReaderView () {};
                ~GearFeedback_DataReaderView () {};
            private:
                GearFeedback_DataReaderView (const GearFeedback_DataReaderView &);
                GearFeedback_DataReaderView & operator = (const GearFeedback_DataReaderView &);
            };
        }

    }

}

#endif
