#ifndef _H_87A2918C103CF3004200E59A90DF486F_SpeedPedals_DCPS_H_
#define _H_87A2918C103CF3004200E59A90DF486F_SpeedPedals_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SpeedPedals_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SpeedPedals_TypeSupportInterface;

            typedef SpeedPedals_TypeSupportInterface * SpeedPedals_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SpeedPedals_TypeSupportInterface> SpeedPedals_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SpeedPedals_TypeSupportInterface> SpeedPedals_TypeSupportInterface_out;


            class SpeedPedals_DataWriter;

            typedef SpeedPedals_DataWriter * SpeedPedals_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SpeedPedals_DataWriter> SpeedPedals_DataWriter_var;
            typedef DDS_DCPSInterface_out < SpeedPedals_DataWriter> SpeedPedals_DataWriter_out;


            class SpeedPedals_DataReader;

            typedef SpeedPedals_DataReader * SpeedPedals_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SpeedPedals_DataReader> SpeedPedals_DataReader_var;
            typedef DDS_DCPSInterface_out < SpeedPedals_DataReader> SpeedPedals_DataReader_out;


            class SpeedPedals_DataReaderView;

            typedef SpeedPedals_DataReaderView * SpeedPedals_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SpeedPedals_DataReaderView> SpeedPedals_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SpeedPedals_DataReaderView> SpeedPedals_DataReaderView_out;

            struct SpeedPedals_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SpeedPedals_, struct SpeedPedals_Seq_uniq_> SpeedPedals_Seq;
            typedef DDS_DCPSSequence_var < SpeedPedals_Seq> SpeedPedals_Seq_var;
            typedef DDS_DCPSSequence_out < SpeedPedals_Seq> SpeedPedals_Seq_out;

            class  SpeedPedals_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SpeedPedals_TypeSupportInterface_ptr _ptr_type;
                typedef SpeedPedals_TypeSupportInterface_var _var_type;

                static SpeedPedals_TypeSupportInterface_ptr _duplicate (SpeedPedals_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SpeedPedals_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SpeedPedals_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SpeedPedals_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SpeedPedals_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SpeedPedals_TypeSupportInterface () {};
                ~SpeedPedals_TypeSupportInterface () {};
            private:
                SpeedPedals_TypeSupportInterface (const SpeedPedals_TypeSupportInterface &);
                SpeedPedals_TypeSupportInterface & operator = (const SpeedPedals_TypeSupportInterface &);
            };

            class  SpeedPedals_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SpeedPedals_DataWriter_ptr _ptr_type;
                typedef SpeedPedals_DataWriter_var _var_type;

                static SpeedPedals_DataWriter_ptr _duplicate (SpeedPedals_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SpeedPedals_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SpeedPedals_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SpeedPedals_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SpeedPedals_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SpeedPedals_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SpeedPedals_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SpeedPedals_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SpeedPedals_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SpeedPedals_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SpeedPedals_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SpeedPedals_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SpeedPedals_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SpeedPedals_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SpeedPedals_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SpeedPedals_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SpeedPedals_& instance_data) = 0;

            protected:
                SpeedPedals_DataWriter () {};
                ~SpeedPedals_DataWriter () {};
            private:
                SpeedPedals_DataWriter (const SpeedPedals_DataWriter &);
                SpeedPedals_DataWriter & operator = (const SpeedPedals_DataWriter &);
            };

            class  SpeedPedals_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SpeedPedals_DataReader_ptr _ptr_type;
                typedef SpeedPedals_DataReader_var _var_type;

                static SpeedPedals_DataReader_ptr _duplicate (SpeedPedals_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SpeedPedals_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SpeedPedals_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SpeedPedals_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SpeedPedals_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SpeedPedals_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SpeedPedals_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SpeedPedals_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SpeedPedals_& instance) = 0;

            protected:
                SpeedPedals_DataReader () {};
                ~SpeedPedals_DataReader () {};
            private:
                SpeedPedals_DataReader (const SpeedPedals_DataReader &);
                SpeedPedals_DataReader & operator = (const SpeedPedals_DataReader &);
            };

            class  SpeedPedals_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SpeedPedals_DataReaderView_ptr _ptr_type;
                typedef SpeedPedals_DataReaderView_var _var_type;

                static SpeedPedals_DataReaderView_ptr _duplicate (SpeedPedals_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SpeedPedals_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SpeedPedals_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SpeedPedals_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SpeedPedals_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SpeedPedals_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SpeedPedals_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SpeedPedals_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SpeedPedals_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SpeedPedals_& instance) = 0;

            protected:
                SpeedPedals_DataReaderView () {};
                ~SpeedPedals_DataReaderView () {};
            private:
                SpeedPedals_DataReaderView (const SpeedPedals_DataReaderView &);
                SpeedPedals_DataReaderView & operator = (const SpeedPedals_DataReaderView &);
            };
        }

    }

}

#endif
