#ifndef _H_D4763D37A98C041D17CB2D2F42C12FDD_SteeringFeedback_DCPS_H_
#define _H_D4763D37A98C041D17CB2D2F42C12FDD_SteeringFeedback_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SteeringFeedback_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SteeringFeedback_TypeSupportInterface;

            typedef SteeringFeedback_TypeSupportInterface * SteeringFeedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SteeringFeedback_TypeSupportInterface> SteeringFeedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SteeringFeedback_TypeSupportInterface> SteeringFeedback_TypeSupportInterface_out;


            class SteeringFeedback_DataWriter;

            typedef SteeringFeedback_DataWriter * SteeringFeedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SteeringFeedback_DataWriter> SteeringFeedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < SteeringFeedback_DataWriter> SteeringFeedback_DataWriter_out;


            class SteeringFeedback_DataReader;

            typedef SteeringFeedback_DataReader * SteeringFeedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SteeringFeedback_DataReader> SteeringFeedback_DataReader_var;
            typedef DDS_DCPSInterface_out < SteeringFeedback_DataReader> SteeringFeedback_DataReader_out;


            class SteeringFeedback_DataReaderView;

            typedef SteeringFeedback_DataReaderView * SteeringFeedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SteeringFeedback_DataReaderView> SteeringFeedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SteeringFeedback_DataReaderView> SteeringFeedback_DataReaderView_out;

            struct SteeringFeedback_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SteeringFeedback_, struct SteeringFeedback_Seq_uniq_> SteeringFeedback_Seq;
            typedef DDS_DCPSSequence_var < SteeringFeedback_Seq> SteeringFeedback_Seq_var;
            typedef DDS_DCPSSequence_out < SteeringFeedback_Seq> SteeringFeedback_Seq_out;

            class  SteeringFeedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SteeringFeedback_TypeSupportInterface_ptr _ptr_type;
                typedef SteeringFeedback_TypeSupportInterface_var _var_type;

                static SteeringFeedback_TypeSupportInterface_ptr _duplicate (SteeringFeedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringFeedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SteeringFeedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringFeedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringFeedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SteeringFeedback_TypeSupportInterface () {};
                ~SteeringFeedback_TypeSupportInterface () {};
            private:
                SteeringFeedback_TypeSupportInterface (const SteeringFeedback_TypeSupportInterface &);
                SteeringFeedback_TypeSupportInterface & operator = (const SteeringFeedback_TypeSupportInterface &);
            };

            class  SteeringFeedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SteeringFeedback_DataWriter_ptr _ptr_type;
                typedef SteeringFeedback_DataWriter_var _var_type;

                static SteeringFeedback_DataWriter_ptr _duplicate (SteeringFeedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringFeedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SteeringFeedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringFeedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringFeedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SteeringFeedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SteeringFeedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SteeringFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SteeringFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SteeringFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SteeringFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SteeringFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SteeringFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SteeringFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SteeringFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SteeringFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SteeringFeedback_& instance_data) = 0;

            protected:
                SteeringFeedback_DataWriter () {};
                ~SteeringFeedback_DataWriter () {};
            private:
                SteeringFeedback_DataWriter (const SteeringFeedback_DataWriter &);
                SteeringFeedback_DataWriter & operator = (const SteeringFeedback_DataWriter &);
            };

            class  SteeringFeedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SteeringFeedback_DataReader_ptr _ptr_type;
                typedef SteeringFeedback_DataReader_var _var_type;

                static SteeringFeedback_DataReader_ptr _duplicate (SteeringFeedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringFeedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SteeringFeedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringFeedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringFeedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SteeringFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SteeringFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SteeringFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SteeringFeedback_& instance) = 0;

            protected:
                SteeringFeedback_DataReader () {};
                ~SteeringFeedback_DataReader () {};
            private:
                SteeringFeedback_DataReader (const SteeringFeedback_DataReader &);
                SteeringFeedback_DataReader & operator = (const SteeringFeedback_DataReader &);
            };

            class  SteeringFeedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SteeringFeedback_DataReaderView_ptr _ptr_type;
                typedef SteeringFeedback_DataReaderView_var _var_type;

                static SteeringFeedback_DataReaderView_ptr _duplicate (SteeringFeedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringFeedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SteeringFeedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringFeedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringFeedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SteeringFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SteeringFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SteeringFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SteeringFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SteeringFeedback_& instance) = 0;

            protected:
                SteeringFeedback_DataReaderView () {};
                ~SteeringFeedback_DataReaderView () {};
            private:
                SteeringFeedback_DataReaderView (const SteeringFeedback_DataReaderView &);
                SteeringFeedback_DataReaderView & operator = (const SteeringFeedback_DataReaderView &);
            };
        }

    }

}

#endif
