#ifndef _H_0E3DB84EB49DEC08C11557F389C76304_TurnSignalCommand_DCPS_H_
#define _H_0E3DB84EB49DEC08C11557F389C76304_TurnSignalCommand_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TurnSignalCommand_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TurnSignalCommand_TypeSupportInterface;

            typedef TurnSignalCommand_TypeSupportInterface * TurnSignalCommand_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TurnSignalCommand_TypeSupportInterface> TurnSignalCommand_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TurnSignalCommand_TypeSupportInterface> TurnSignalCommand_TypeSupportInterface_out;


            class TurnSignalCommand_DataWriter;

            typedef TurnSignalCommand_DataWriter * TurnSignalCommand_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TurnSignalCommand_DataWriter> TurnSignalCommand_DataWriter_var;
            typedef DDS_DCPSInterface_out < TurnSignalCommand_DataWriter> TurnSignalCommand_DataWriter_out;


            class TurnSignalCommand_DataReader;

            typedef TurnSignalCommand_DataReader * TurnSignalCommand_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TurnSignalCommand_DataReader> TurnSignalCommand_DataReader_var;
            typedef DDS_DCPSInterface_out < TurnSignalCommand_DataReader> TurnSignalCommand_DataReader_out;


            class TurnSignalCommand_DataReaderView;

            typedef TurnSignalCommand_DataReaderView * TurnSignalCommand_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TurnSignalCommand_DataReaderView> TurnSignalCommand_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TurnSignalCommand_DataReaderView> TurnSignalCommand_DataReaderView_out;

            struct TurnSignalCommand_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TurnSignalCommand_, struct TurnSignalCommand_Seq_uniq_> TurnSignalCommand_Seq;
            typedef DDS_DCPSSequence_var < TurnSignalCommand_Seq> TurnSignalCommand_Seq_var;
            typedef DDS_DCPSSequence_out < TurnSignalCommand_Seq> TurnSignalCommand_Seq_out;

            class  TurnSignalCommand_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TurnSignalCommand_TypeSupportInterface_ptr _ptr_type;
                typedef TurnSignalCommand_TypeSupportInterface_var _var_type;

                static TurnSignalCommand_TypeSupportInterface_ptr _duplicate (TurnSignalCommand_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TurnSignalCommand_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TurnSignalCommand_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TurnSignalCommand_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TurnSignalCommand_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TurnSignalCommand_TypeSupportInterface () {};
                ~TurnSignalCommand_TypeSupportInterface () {};
            private:
                TurnSignalCommand_TypeSupportInterface (const TurnSignalCommand_TypeSupportInterface &);
                TurnSignalCommand_TypeSupportInterface & operator = (const TurnSignalCommand_TypeSupportInterface &);
            };

            class  TurnSignalCommand_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TurnSignalCommand_DataWriter_ptr _ptr_type;
                typedef TurnSignalCommand_DataWriter_var _var_type;

                static TurnSignalCommand_DataWriter_ptr _duplicate (TurnSignalCommand_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TurnSignalCommand_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TurnSignalCommand_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TurnSignalCommand_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TurnSignalCommand_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TurnSignalCommand_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TurnSignalCommand_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TurnSignalCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TurnSignalCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TurnSignalCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TurnSignalCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TurnSignalCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TurnSignalCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TurnSignalCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TurnSignalCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TurnSignalCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TurnSignalCommand_& instance_data) = 0;

            protected:
                TurnSignalCommand_DataWriter () {};
                ~TurnSignalCommand_DataWriter () {};
            private:
                TurnSignalCommand_DataWriter (const TurnSignalCommand_DataWriter &);
                TurnSignalCommand_DataWriter & operator = (const TurnSignalCommand_DataWriter &);
            };

            class  TurnSignalCommand_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TurnSignalCommand_DataReader_ptr _ptr_type;
                typedef TurnSignalCommand_DataReader_var _var_type;

                static TurnSignalCommand_DataReader_ptr _duplicate (TurnSignalCommand_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TurnSignalCommand_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TurnSignalCommand_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TurnSignalCommand_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TurnSignalCommand_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TurnSignalCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TurnSignalCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TurnSignalCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TurnSignalCommand_& instance) = 0;

            protected:
                TurnSignalCommand_DataReader () {};
                ~TurnSignalCommand_DataReader () {};
            private:
                TurnSignalCommand_DataReader (const TurnSignalCommand_DataReader &);
                TurnSignalCommand_DataReader & operator = (const TurnSignalCommand_DataReader &);
            };

            class  TurnSignalCommand_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TurnSignalCommand_DataReaderView_ptr _ptr_type;
                typedef TurnSignalCommand_DataReaderView_var _var_type;

                static TurnSignalCommand_DataReaderView_ptr _duplicate (TurnSignalCommand_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TurnSignalCommand_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TurnSignalCommand_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TurnSignalCommand_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TurnSignalCommand_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TurnSignalCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TurnSignalCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TurnSignalCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TurnSignalCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TurnSignalCommand_& instance) = 0;

            protected:
                TurnSignalCommand_DataReaderView () {};
                ~TurnSignalCommand_DataReaderView () {};
            private:
                TurnSignalCommand_DataReaderView (const TurnSignalCommand_DataReaderView &);
                TurnSignalCommand_DataReaderView & operator = (const TurnSignalCommand_DataReaderView &);
            };
        }

    }

}

#endif
