#ifndef _H_F0A20B2F66B23490A6C16F0DA5B49311_UserInputADAS_DCPS_H_
#define _H_F0A20B2F66B23490A6C16F0DA5B49311_UserInputADAS_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "UserInputADAS_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class UserInputADAS_TypeSupportInterface;

            typedef UserInputADAS_TypeSupportInterface * UserInputADAS_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UserInputADAS_TypeSupportInterface> UserInputADAS_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UserInputADAS_TypeSupportInterface> UserInputADAS_TypeSupportInterface_out;


            class UserInputADAS_DataWriter;

            typedef UserInputADAS_DataWriter * UserInputADAS_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UserInputADAS_DataWriter> UserInputADAS_DataWriter_var;
            typedef DDS_DCPSInterface_out < UserInputADAS_DataWriter> UserInputADAS_DataWriter_out;


            class UserInputADAS_DataReader;

            typedef UserInputADAS_DataReader * UserInputADAS_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UserInputADAS_DataReader> UserInputADAS_DataReader_var;
            typedef DDS_DCPSInterface_out < UserInputADAS_DataReader> UserInputADAS_DataReader_out;


            class UserInputADAS_DataReaderView;

            typedef UserInputADAS_DataReaderView * UserInputADAS_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UserInputADAS_DataReaderView> UserInputADAS_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UserInputADAS_DataReaderView> UserInputADAS_DataReaderView_out;

            struct UserInputADAS_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < UserInputADAS_, struct UserInputADAS_Seq_uniq_> UserInputADAS_Seq;
            typedef DDS_DCPSSequence_var < UserInputADAS_Seq> UserInputADAS_Seq_var;
            typedef DDS_DCPSSequence_out < UserInputADAS_Seq> UserInputADAS_Seq_out;

            class  UserInputADAS_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UserInputADAS_TypeSupportInterface_ptr _ptr_type;
                typedef UserInputADAS_TypeSupportInterface_var _var_type;

                static UserInputADAS_TypeSupportInterface_ptr _duplicate (UserInputADAS_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UserInputADAS_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UserInputADAS_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UserInputADAS_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UserInputADAS_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UserInputADAS_TypeSupportInterface () {};
                ~UserInputADAS_TypeSupportInterface () {};
            private:
                UserInputADAS_TypeSupportInterface (const UserInputADAS_TypeSupportInterface &);
                UserInputADAS_TypeSupportInterface & operator = (const UserInputADAS_TypeSupportInterface &);
            };

            class  UserInputADAS_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UserInputADAS_DataWriter_ptr _ptr_type;
                typedef UserInputADAS_DataWriter_var _var_type;

                static UserInputADAS_DataWriter_ptr _duplicate (UserInputADAS_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UserInputADAS_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UserInputADAS_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UserInputADAS_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UserInputADAS_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UserInputADAS_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UserInputADAS_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UserInputADAS_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UserInputADAS_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UserInputADAS_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UserInputADAS_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UserInputADAS_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UserInputADAS_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UserInputADAS_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UserInputADAS_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UserInputADAS_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UserInputADAS_& instance_data) = 0;

            protected:
                UserInputADAS_DataWriter () {};
                ~UserInputADAS_DataWriter () {};
            private:
                UserInputADAS_DataWriter (const UserInputADAS_DataWriter &);
                UserInputADAS_DataWriter & operator = (const UserInputADAS_DataWriter &);
            };

            class  UserInputADAS_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UserInputADAS_DataReader_ptr _ptr_type;
                typedef UserInputADAS_DataReader_var _var_type;

                static UserInputADAS_DataReader_ptr _duplicate (UserInputADAS_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UserInputADAS_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UserInputADAS_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UserInputADAS_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UserInputADAS_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UserInputADAS_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UserInputADAS_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UserInputADAS_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UserInputADAS_& instance) = 0;

            protected:
                UserInputADAS_DataReader () {};
                ~UserInputADAS_DataReader () {};
            private:
                UserInputADAS_DataReader (const UserInputADAS_DataReader &);
                UserInputADAS_DataReader & operator = (const UserInputADAS_DataReader &);
            };

            class  UserInputADAS_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UserInputADAS_DataReaderView_ptr _ptr_type;
                typedef UserInputADAS_DataReaderView_var _var_type;

                static UserInputADAS_DataReaderView_ptr _duplicate (UserInputADAS_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UserInputADAS_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UserInputADAS_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UserInputADAS_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UserInputADAS_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UserInputADAS_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UserInputADAS_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UserInputADAS_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UserInputADAS_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UserInputADAS_& instance) = 0;

            protected:
                UserInputADAS_DataReaderView () {};
                ~UserInputADAS_DataReaderView () {};
            private:
                UserInputADAS_DataReaderView (const UserInputADAS_DataReaderView &);
                UserInputADAS_DataReaderView & operator = (const UserInputADAS_DataReaderView &);
            };
        }

    }

}

#endif
