#ifndef _H_FAB3A25E65AEC3035367B021EFB2739B_UserInputMenus__H_
#define _H_FAB3A25E65AEC3035367B021EFB2739B_UserInputMenus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  UserInputMenus_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean str_whl_left_btn_left_;
                ::DDS::Boolean str_whl_left_btn_down_;
                ::DDS::Boolean str_whl_left_btn_right_;
                ::DDS::Boolean str_whl_left_btn_up_;
                ::DDS::Boolean str_whl_left_btn_ok_;
                ::DDS::Boolean str_whl_right_btn_left_;
                ::DDS::Boolean str_whl_right_btn_down_;
                ::DDS::Boolean str_whl_right_btn_right_;
                ::DDS::Boolean str_whl_right_btn_up_;
                ::DDS::Boolean str_whl_right_btn_ok_;
                ::DDS::Boolean cntr_cons_btn_left_;
                ::DDS::Boolean cntr_cons_btn_down_;
                ::DDS::Boolean cntr_cons_btn_right_;
                ::DDS::Boolean cntr_cons_btn_up_;
                ::DDS::Boolean cntr_cons_btn_ok_;
            };

            typedef DDS_DCPSStruct_var<UserInputMenus_> UserInputMenus__var;
            typedef DDS_DCPSStruct_out < UserInputMenus_> UserInputMenus__out;

        }

    }

}

#endif /* _H_FAB3A25E65AEC3035367B021EFB2739B_UserInputMenus__H_ */
