#ifndef _H_FAB3A25E65AEC3035367B021EFB2739B_UserInputMenus_DCPS_H_
#define _H_FAB3A25E65AEC3035367B021EFB2739B_UserInputMenus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "UserInputMenus_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class UserInputMenus_TypeSupportInterface;

            typedef UserInputMenus_TypeSupportInterface * UserInputMenus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < UserInputMenus_TypeSupportInterface> UserInputMenus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < UserInputMenus_TypeSupportInterface> UserInputMenus_TypeSupportInterface_out;


            class UserInputMenus_DataWriter;

            typedef UserInputMenus_DataWriter * UserInputMenus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < UserInputMenus_DataWriter> UserInputMenus_DataWriter_var;
            typedef DDS_DCPSInterface_out < UserInputMenus_DataWriter> UserInputMenus_DataWriter_out;


            class UserInputMenus_DataReader;

            typedef UserInputMenus_DataReader * UserInputMenus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < UserInputMenus_DataReader> UserInputMenus_DataReader_var;
            typedef DDS_DCPSInterface_out < UserInputMenus_DataReader> UserInputMenus_DataReader_out;


            class UserInputMenus_DataReaderView;

            typedef UserInputMenus_DataReaderView * UserInputMenus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < UserInputMenus_DataReaderView> UserInputMenus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < UserInputMenus_DataReaderView> UserInputMenus_DataReaderView_out;

            struct UserInputMenus_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < UserInputMenus_, struct UserInputMenus_Seq_uniq_> UserInputMenus_Seq;
            typedef DDS_DCPSSequence_var < UserInputMenus_Seq> UserInputMenus_Seq_var;
            typedef DDS_DCPSSequence_out < UserInputMenus_Seq> UserInputMenus_Seq_out;

            class  UserInputMenus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef UserInputMenus_TypeSupportInterface_ptr _ptr_type;
                typedef UserInputMenus_TypeSupportInterface_var _var_type;

                static UserInputMenus_TypeSupportInterface_ptr _duplicate (UserInputMenus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UserInputMenus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static UserInputMenus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UserInputMenus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                UserInputMenus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                UserInputMenus_TypeSupportInterface () {};
                ~UserInputMenus_TypeSupportInterface () {};
            private:
                UserInputMenus_TypeSupportInterface (const UserInputMenus_TypeSupportInterface &);
                UserInputMenus_TypeSupportInterface & operator = (const UserInputMenus_TypeSupportInterface &);
            };

            class  UserInputMenus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef UserInputMenus_DataWriter_ptr _ptr_type;
                typedef UserInputMenus_DataWriter_var _var_type;

                static UserInputMenus_DataWriter_ptr _duplicate (UserInputMenus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UserInputMenus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static UserInputMenus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UserInputMenus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                UserInputMenus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const UserInputMenus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const UserInputMenus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const UserInputMenus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const UserInputMenus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const UserInputMenus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const UserInputMenus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const UserInputMenus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const UserInputMenus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const UserInputMenus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const UserInputMenus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (UserInputMenus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UserInputMenus_& instance_data) = 0;

            protected:
                UserInputMenus_DataWriter () {};
                ~UserInputMenus_DataWriter () {};
            private:
                UserInputMenus_DataWriter (const UserInputMenus_DataWriter &);
                UserInputMenus_DataWriter & operator = (const UserInputMenus_DataWriter &);
            };

            class  UserInputMenus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef UserInputMenus_DataReader_ptr _ptr_type;
                typedef UserInputMenus_DataReader_var _var_type;

                static UserInputMenus_DataReader_ptr _duplicate (UserInputMenus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UserInputMenus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static UserInputMenus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UserInputMenus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                UserInputMenus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UserInputMenus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UserInputMenus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UserInputMenus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UserInputMenus_& instance) = 0;

            protected:
                UserInputMenus_DataReader () {};
                ~UserInputMenus_DataReader () {};
            private:
                UserInputMenus_DataReader (const UserInputMenus_DataReader &);
                UserInputMenus_DataReader & operator = (const UserInputMenus_DataReader &);
            };

            class  UserInputMenus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef UserInputMenus_DataReaderView_ptr _ptr_type;
                typedef UserInputMenus_DataReaderView_var _var_type;

                static UserInputMenus_DataReaderView_ptr _duplicate (UserInputMenus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static UserInputMenus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static UserInputMenus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static UserInputMenus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                UserInputMenus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (UserInputMenus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (UserInputMenus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (UserInputMenus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (UserInputMenus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const UserInputMenus_& instance) = 0;

            protected:
                UserInputMenus_DataReaderView () {};
                ~UserInputMenus_DataReaderView () {};
            private:
                UserInputMenus_DataReaderView (const UserInputMenus_DataReaderView &);
                UserInputMenus_DataReaderView & operator = (const UserInputMenus_DataReaderView &);
            };
        }

    }

}

#endif
