// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from automotive_platform_msgs:msg/Gear.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__GEAR__FUNCTIONS_H_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__GEAR__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "automotive_platform_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "automotive_platform_msgs/msg/gear__struct.h"

/// Initialize msg/Gear message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * automotive_platform_msgs__msg__Gear
 * )) before or use
 * automotive_platform_msgs__msg__Gear__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_platform_msgs
bool
automotive_platform_msgs__msg__Gear__init(automotive_platform_msgs__msg__Gear * msg);

/// Finalize msg/Gear message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_platform_msgs
void
automotive_platform_msgs__msg__Gear__fini(automotive_platform_msgs__msg__Gear * msg);

/// Create msg/Gear message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * automotive_platform_msgs__msg__Gear__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_platform_msgs
automotive_platform_msgs__msg__Gear *
automotive_platform_msgs__msg__Gear__create();

/// Destroy msg/Gear message.
/**
 * It calls
 * automotive_platform_msgs__msg__Gear__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_platform_msgs
void
automotive_platform_msgs__msg__Gear__destroy(automotive_platform_msgs__msg__Gear * msg);


/// Initialize array of msg/Gear messages.
/**
 * It allocates the memory for the number of elements and calls
 * automotive_platform_msgs__msg__Gear__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_platform_msgs
bool
automotive_platform_msgs__msg__Gear__Sequence__init(automotive_platform_msgs__msg__Gear__Sequence * array, size_t size);

/// Finalize array of msg/Gear messages.
/**
 * It calls
 * automotive_platform_msgs__msg__Gear__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_platform_msgs
void
automotive_platform_msgs__msg__Gear__Sequence__fini(automotive_platform_msgs__msg__Gear__Sequence * array);

/// Create array of msg/Gear messages.
/**
 * It allocates the memory for the array and calls
 * automotive_platform_msgs__msg__Gear__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_platform_msgs
automotive_platform_msgs__msg__Gear__Sequence *
automotive_platform_msgs__msg__Gear__Sequence__create(size_t size);

/// Destroy array of msg/Gear messages.
/**
 * It calls
 * automotive_platform_msgs__msg__Gear__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_automotive_platform_msgs
void
automotive_platform_msgs__msg__Gear__Sequence__destroy(automotive_platform_msgs__msg__Gear__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__GEAR__FUNCTIONS_H_
