// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_platform_msgs:msg/Gear.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__GEAR__STRUCT_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__GEAR__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__automotive_platform_msgs__msg__Gear __attribute__((deprecated))
#else
# define DEPRECATED__automotive_platform_msgs__msg__Gear __declspec(deprecated)
#endif

namespace automotive_platform_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Gear_
{
  using Type = Gear_<ContainerAllocator>;

  explicit Gear_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->gear = 0;
    }
  }

  explicit Gear_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->gear = 0;
    }
  }

  // field types and members
  using _gear_type =
    uint8_t;
  _gear_type gear;

  // setters for named parameter idiom
  Type & set__gear(
    const uint8_t & _arg)
  {
    this->gear = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t NONE =
    0u;
  static constexpr uint8_t PARK =
    1u;
  static constexpr uint8_t REVERSE =
    2u;
  static constexpr uint8_t NEUTRAL =
    3u;
  static constexpr uint8_t DRIVE =
    4u;
  static constexpr uint8_t LOW =
    5u;

  // pointer types
  using RawPtr =
    automotive_platform_msgs::msg::Gear_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_platform_msgs::msg::Gear_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::Gear_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::Gear_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::Gear_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::Gear_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::Gear_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::Gear_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::Gear_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::Gear_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_platform_msgs__msg__Gear
    std::shared_ptr<automotive_platform_msgs::msg::Gear_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_platform_msgs__msg__Gear
    std::shared_ptr<automotive_platform_msgs::msg::Gear_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Gear_ & other) const
  {
    if (this->gear != other.gear) {
      return false;
    }
    return true;
  }
  bool operator!=(const Gear_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Gear_

// alias to use template instance with default allocator
using Gear =
  automotive_platform_msgs::msg::Gear_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t Gear_<ContainerAllocator>::NONE;
template<typename ContainerAllocator>
constexpr uint8_t Gear_<ContainerAllocator>::PARK;
template<typename ContainerAllocator>
constexpr uint8_t Gear_<ContainerAllocator>::REVERSE;
template<typename ContainerAllocator>
constexpr uint8_t Gear_<ContainerAllocator>::NEUTRAL;
template<typename ContainerAllocator>
constexpr uint8_t Gear_<ContainerAllocator>::DRIVE;
template<typename ContainerAllocator>
constexpr uint8_t Gear_<ContainerAllocator>::LOW;

}  // namespace msg

}  // namespace automotive_platform_msgs

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__GEAR__STRUCT_HPP_
