// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_platform_msgs:msg/SpeedMode.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__SPEED_MODE__STRUCT_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__SPEED_MODE__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_platform_msgs__msg__SpeedMode __attribute__((deprecated))
#else
# define DEPRECATED__automotive_platform_msgs__msg__SpeedMode __declspec(deprecated)
#endif

namespace automotive_platform_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SpeedMode_
{
  using Type = SpeedMode_<ContainerAllocator>;

  explicit SpeedMode_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->mode = 0;
      this->speed = 0.0f;
      this->acceleration_limit = 0.0f;
      this->deceleration_limit = 0.0f;
    }
  }

  explicit SpeedMode_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->mode = 0;
      this->speed = 0.0f;
      this->acceleration_limit = 0.0f;
      this->deceleration_limit = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _mode_type =
    uint16_t;
  _mode_type mode;
  using _speed_type =
    float;
  _speed_type speed;
  using _acceleration_limit_type =
    float;
  _acceleration_limit_type acceleration_limit;
  using _deceleration_limit_type =
    float;
  _deceleration_limit_type deceleration_limit;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__mode(
    const uint16_t & _arg)
  {
    this->mode = _arg;
    return *this;
  }
  Type & set__speed(
    const float & _arg)
  {
    this->speed = _arg;
    return *this;
  }
  Type & set__acceleration_limit(
    const float & _arg)
  {
    this->acceleration_limit = _arg;
    return *this;
  }
  Type & set__deceleration_limit(
    const float & _arg)
  {
    this->deceleration_limit = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_platform_msgs::msg::SpeedMode_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_platform_msgs::msg::SpeedMode_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::SpeedMode_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::SpeedMode_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::SpeedMode_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::SpeedMode_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::SpeedMode_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::SpeedMode_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::SpeedMode_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::SpeedMode_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_platform_msgs__msg__SpeedMode
    std::shared_ptr<automotive_platform_msgs::msg::SpeedMode_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_platform_msgs__msg__SpeedMode
    std::shared_ptr<automotive_platform_msgs::msg::SpeedMode_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SpeedMode_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->mode != other.mode) {
      return false;
    }
    if (this->speed != other.speed) {
      return false;
    }
    if (this->acceleration_limit != other.acceleration_limit) {
      return false;
    }
    if (this->deceleration_limit != other.deceleration_limit) {
      return false;
    }
    return true;
  }
  bool operator!=(const SpeedMode_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SpeedMode_

// alias to use template instance with default allocator
using SpeedMode =
  automotive_platform_msgs::msg::SpeedMode_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_platform_msgs

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__SPEED_MODE__STRUCT_HPP_
