// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_platform_msgs:msg/SpeedPedals.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__SPEED_PEDALS__STRUCT_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__SPEED_PEDALS__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_platform_msgs__msg__SpeedPedals __attribute__((deprecated))
#else
# define DEPRECATED__automotive_platform_msgs__msg__SpeedPedals __declspec(deprecated)
#endif

namespace automotive_platform_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SpeedPedals_
{
  using Type = SpeedPedals_<ContainerAllocator>;

  explicit SpeedPedals_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->mode = 0;
      this->throttle = 0.0f;
      this->brake = 0.0f;
    }
  }

  explicit SpeedPedals_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->mode = 0;
      this->throttle = 0.0f;
      this->brake = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _mode_type =
    uint16_t;
  _mode_type mode;
  using _throttle_type =
    float;
  _throttle_type throttle;
  using _brake_type =
    float;
  _brake_type brake;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__mode(
    const uint16_t & _arg)
  {
    this->mode = _arg;
    return *this;
  }
  Type & set__throttle(
    const float & _arg)
  {
    this->throttle = _arg;
    return *this;
  }
  Type & set__brake(
    const float & _arg)
  {
    this->brake = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_platform_msgs::msg::SpeedPedals_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_platform_msgs::msg::SpeedPedals_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::SpeedPedals_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::SpeedPedals_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::SpeedPedals_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::SpeedPedals_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::SpeedPedals_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::SpeedPedals_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::SpeedPedals_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::SpeedPedals_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_platform_msgs__msg__SpeedPedals
    std::shared_ptr<automotive_platform_msgs::msg::SpeedPedals_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_platform_msgs__msg__SpeedPedals
    std::shared_ptr<automotive_platform_msgs::msg::SpeedPedals_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SpeedPedals_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->mode != other.mode) {
      return false;
    }
    if (this->throttle != other.throttle) {
      return false;
    }
    if (this->brake != other.brake) {
      return false;
    }
    return true;
  }
  bool operator!=(const SpeedPedals_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SpeedPedals_

// alias to use template instance with default allocator
using SpeedPedals =
  automotive_platform_msgs::msg::SpeedPedals_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_platform_msgs

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__SPEED_PEDALS__STRUCT_HPP_
