// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_platform_msgs:msg/SteeringCommand.idl
// generated code does not contain a copyright notice
#include "automotive_platform_msgs/msg/steering_command__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"

bool
automotive_platform_msgs__msg__SteeringCommand__init(automotive_platform_msgs__msg__SteeringCommand * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    automotive_platform_msgs__msg__SteeringCommand__fini(msg);
    return false;
  }
  // steering_wheel_angle
  return true;
}

void
automotive_platform_msgs__msg__SteeringCommand__fini(automotive_platform_msgs__msg__SteeringCommand * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // steering_wheel_angle
}

automotive_platform_msgs__msg__SteeringCommand *
automotive_platform_msgs__msg__SteeringCommand__create()
{
  automotive_platform_msgs__msg__SteeringCommand * msg = (automotive_platform_msgs__msg__SteeringCommand *)malloc(sizeof(automotive_platform_msgs__msg__SteeringCommand));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_platform_msgs__msg__SteeringCommand));
  bool success = automotive_platform_msgs__msg__SteeringCommand__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
automotive_platform_msgs__msg__SteeringCommand__destroy(automotive_platform_msgs__msg__SteeringCommand * msg)
{
  if (msg) {
    automotive_platform_msgs__msg__SteeringCommand__fini(msg);
  }
  free(msg);
}


bool
automotive_platform_msgs__msg__SteeringCommand__Sequence__init(automotive_platform_msgs__msg__SteeringCommand__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  automotive_platform_msgs__msg__SteeringCommand * data = NULL;
  if (size) {
    data = (automotive_platform_msgs__msg__SteeringCommand *)calloc(size, sizeof(automotive_platform_msgs__msg__SteeringCommand));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_platform_msgs__msg__SteeringCommand__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_platform_msgs__msg__SteeringCommand__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_platform_msgs__msg__SteeringCommand__Sequence__fini(automotive_platform_msgs__msg__SteeringCommand__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_platform_msgs__msg__SteeringCommand__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_platform_msgs__msg__SteeringCommand__Sequence *
automotive_platform_msgs__msg__SteeringCommand__Sequence__create(size_t size)
{
  automotive_platform_msgs__msg__SteeringCommand__Sequence * array = (automotive_platform_msgs__msg__SteeringCommand__Sequence *)malloc(sizeof(automotive_platform_msgs__msg__SteeringCommand__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = automotive_platform_msgs__msg__SteeringCommand__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
automotive_platform_msgs__msg__SteeringCommand__Sequence__destroy(automotive_platform_msgs__msg__SteeringCommand__Sequence * array)
{
  if (array) {
    automotive_platform_msgs__msg__SteeringCommand__Sequence__fini(array);
  }
  free(array);
}
