// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_platform_msgs:msg/UserInputADAS.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__USER_INPUT_ADAS__STRUCT_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__USER_INPUT_ADAS__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_platform_msgs__msg__UserInputADAS __attribute__((deprecated))
#else
# define DEPRECATED__automotive_platform_msgs__msg__UserInputADAS __declspec(deprecated)
#endif

namespace automotive_platform_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct UserInputADAS_
{
  using Type = UserInputADAS_<ContainerAllocator>;

  explicit UserInputADAS_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->btn_cc_on = false;
      this->btn_cc_off = false;
      this->btn_cc_on_off = false;
      this->btn_cc_set_inc = false;
      this->btn_cc_set_dec = false;
      this->btn_cc_res = false;
      this->btn_cc_cncl = false;
      this->btn_cc_res_cncl = false;
      this->btn_acc_gap_inc = false;
      this->btn_acc_gap_dec = false;
      this->btn_lka_on = false;
      this->btn_lka_off = false;
      this->btn_lka_on_off = false;
    }
  }

  explicit UserInputADAS_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->btn_cc_on = false;
      this->btn_cc_off = false;
      this->btn_cc_on_off = false;
      this->btn_cc_set_inc = false;
      this->btn_cc_set_dec = false;
      this->btn_cc_res = false;
      this->btn_cc_cncl = false;
      this->btn_cc_res_cncl = false;
      this->btn_acc_gap_inc = false;
      this->btn_acc_gap_dec = false;
      this->btn_lka_on = false;
      this->btn_lka_off = false;
      this->btn_lka_on_off = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _btn_cc_on_type =
    bool;
  _btn_cc_on_type btn_cc_on;
  using _btn_cc_off_type =
    bool;
  _btn_cc_off_type btn_cc_off;
  using _btn_cc_on_off_type =
    bool;
  _btn_cc_on_off_type btn_cc_on_off;
  using _btn_cc_set_inc_type =
    bool;
  _btn_cc_set_inc_type btn_cc_set_inc;
  using _btn_cc_set_dec_type =
    bool;
  _btn_cc_set_dec_type btn_cc_set_dec;
  using _btn_cc_res_type =
    bool;
  _btn_cc_res_type btn_cc_res;
  using _btn_cc_cncl_type =
    bool;
  _btn_cc_cncl_type btn_cc_cncl;
  using _btn_cc_res_cncl_type =
    bool;
  _btn_cc_res_cncl_type btn_cc_res_cncl;
  using _btn_acc_gap_inc_type =
    bool;
  _btn_acc_gap_inc_type btn_acc_gap_inc;
  using _btn_acc_gap_dec_type =
    bool;
  _btn_acc_gap_dec_type btn_acc_gap_dec;
  using _btn_lka_on_type =
    bool;
  _btn_lka_on_type btn_lka_on;
  using _btn_lka_off_type =
    bool;
  _btn_lka_off_type btn_lka_off;
  using _btn_lka_on_off_type =
    bool;
  _btn_lka_on_off_type btn_lka_on_off;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__btn_cc_on(
    const bool & _arg)
  {
    this->btn_cc_on = _arg;
    return *this;
  }
  Type & set__btn_cc_off(
    const bool & _arg)
  {
    this->btn_cc_off = _arg;
    return *this;
  }
  Type & set__btn_cc_on_off(
    const bool & _arg)
  {
    this->btn_cc_on_off = _arg;
    return *this;
  }
  Type & set__btn_cc_set_inc(
    const bool & _arg)
  {
    this->btn_cc_set_inc = _arg;
    return *this;
  }
  Type & set__btn_cc_set_dec(
    const bool & _arg)
  {
    this->btn_cc_set_dec = _arg;
    return *this;
  }
  Type & set__btn_cc_res(
    const bool & _arg)
  {
    this->btn_cc_res = _arg;
    return *this;
  }
  Type & set__btn_cc_cncl(
    const bool & _arg)
  {
    this->btn_cc_cncl = _arg;
    return *this;
  }
  Type & set__btn_cc_res_cncl(
    const bool & _arg)
  {
    this->btn_cc_res_cncl = _arg;
    return *this;
  }
  Type & set__btn_acc_gap_inc(
    const bool & _arg)
  {
    this->btn_acc_gap_inc = _arg;
    return *this;
  }
  Type & set__btn_acc_gap_dec(
    const bool & _arg)
  {
    this->btn_acc_gap_dec = _arg;
    return *this;
  }
  Type & set__btn_lka_on(
    const bool & _arg)
  {
    this->btn_lka_on = _arg;
    return *this;
  }
  Type & set__btn_lka_off(
    const bool & _arg)
  {
    this->btn_lka_off = _arg;
    return *this;
  }
  Type & set__btn_lka_on_off(
    const bool & _arg)
  {
    this->btn_lka_on_off = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_platform_msgs::msg::UserInputADAS_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_platform_msgs::msg::UserInputADAS_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::UserInputADAS_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::UserInputADAS_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::UserInputADAS_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::UserInputADAS_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::UserInputADAS_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::UserInputADAS_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::UserInputADAS_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::UserInputADAS_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_platform_msgs__msg__UserInputADAS
    std::shared_ptr<automotive_platform_msgs::msg::UserInputADAS_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_platform_msgs__msg__UserInputADAS
    std::shared_ptr<automotive_platform_msgs::msg::UserInputADAS_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const UserInputADAS_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->btn_cc_on != other.btn_cc_on) {
      return false;
    }
    if (this->btn_cc_off != other.btn_cc_off) {
      return false;
    }
    if (this->btn_cc_on_off != other.btn_cc_on_off) {
      return false;
    }
    if (this->btn_cc_set_inc != other.btn_cc_set_inc) {
      return false;
    }
    if (this->btn_cc_set_dec != other.btn_cc_set_dec) {
      return false;
    }
    if (this->btn_cc_res != other.btn_cc_res) {
      return false;
    }
    if (this->btn_cc_cncl != other.btn_cc_cncl) {
      return false;
    }
    if (this->btn_cc_res_cncl != other.btn_cc_res_cncl) {
      return false;
    }
    if (this->btn_acc_gap_inc != other.btn_acc_gap_inc) {
      return false;
    }
    if (this->btn_acc_gap_dec != other.btn_acc_gap_dec) {
      return false;
    }
    if (this->btn_lka_on != other.btn_lka_on) {
      return false;
    }
    if (this->btn_lka_off != other.btn_lka_off) {
      return false;
    }
    if (this->btn_lka_on_off != other.btn_lka_on_off) {
      return false;
    }
    return true;
  }
  bool operator!=(const UserInputADAS_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct UserInputADAS_

// alias to use template instance with default allocator
using UserInputADAS =
  automotive_platform_msgs::msg::UserInputADAS_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_platform_msgs

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__USER_INPUT_ADAS__STRUCT_HPP_
