// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_platform_msgs:msg/UserInputMedia.idl
// generated code does not contain a copyright notice
#include "automotive_platform_msgs/msg/user_input_media__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"

bool
automotive_platform_msgs__msg__UserInputMedia__init(automotive_platform_msgs__msg__UserInputMedia * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    automotive_platform_msgs__msg__UserInputMedia__fini(msg);
    return false;
  }
  // btn_vol_up
  // btn_vol_down
  // btn_mute
  // btn_next
  // btn_prev
  // btn_next_hang_up
  // btn_prev_answer
  // btn_hang_up
  // btn_answer
  // btn_play
  // btn_pause
  // btn_play_pause
  // btn_mode
  return true;
}

void
automotive_platform_msgs__msg__UserInputMedia__fini(automotive_platform_msgs__msg__UserInputMedia * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // btn_vol_up
  // btn_vol_down
  // btn_mute
  // btn_next
  // btn_prev
  // btn_next_hang_up
  // btn_prev_answer
  // btn_hang_up
  // btn_answer
  // btn_play
  // btn_pause
  // btn_play_pause
  // btn_mode
}

automotive_platform_msgs__msg__UserInputMedia *
automotive_platform_msgs__msg__UserInputMedia__create()
{
  automotive_platform_msgs__msg__UserInputMedia * msg = (automotive_platform_msgs__msg__UserInputMedia *)malloc(sizeof(automotive_platform_msgs__msg__UserInputMedia));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_platform_msgs__msg__UserInputMedia));
  bool success = automotive_platform_msgs__msg__UserInputMedia__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
automotive_platform_msgs__msg__UserInputMedia__destroy(automotive_platform_msgs__msg__UserInputMedia * msg)
{
  if (msg) {
    automotive_platform_msgs__msg__UserInputMedia__fini(msg);
  }
  free(msg);
}


bool
automotive_platform_msgs__msg__UserInputMedia__Sequence__init(automotive_platform_msgs__msg__UserInputMedia__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  automotive_platform_msgs__msg__UserInputMedia * data = NULL;
  if (size) {
    data = (automotive_platform_msgs__msg__UserInputMedia *)calloc(size, sizeof(automotive_platform_msgs__msg__UserInputMedia));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_platform_msgs__msg__UserInputMedia__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_platform_msgs__msg__UserInputMedia__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_platform_msgs__msg__UserInputMedia__Sequence__fini(automotive_platform_msgs__msg__UserInputMedia__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_platform_msgs__msg__UserInputMedia__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_platform_msgs__msg__UserInputMedia__Sequence *
automotive_platform_msgs__msg__UserInputMedia__Sequence__create(size_t size)
{
  automotive_platform_msgs__msg__UserInputMedia__Sequence * array = (automotive_platform_msgs__msg__UserInputMedia__Sequence *)malloc(sizeof(automotive_platform_msgs__msg__UserInputMedia__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = automotive_platform_msgs__msg__UserInputMedia__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
automotive_platform_msgs__msg__UserInputMedia__Sequence__destroy(automotive_platform_msgs__msg__UserInputMedia__Sequence * array)
{
  if (array) {
    automotive_platform_msgs__msg__UserInputMedia__Sequence__fini(array);
  }
  free(array);
}
