// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_platform_msgs:msg/UserInputMedia.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__USER_INPUT_MEDIA__STRUCT_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__USER_INPUT_MEDIA__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_platform_msgs__msg__UserInputMedia __attribute__((deprecated))
#else
# define DEPRECATED__automotive_platform_msgs__msg__UserInputMedia __declspec(deprecated)
#endif

namespace automotive_platform_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct UserInputMedia_
{
  using Type = UserInputMedia_<ContainerAllocator>;

  explicit UserInputMedia_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->btn_vol_up = false;
      this->btn_vol_down = false;
      this->btn_mute = false;
      this->btn_next = false;
      this->btn_prev = false;
      this->btn_next_hang_up = false;
      this->btn_prev_answer = false;
      this->btn_hang_up = false;
      this->btn_answer = false;
      this->btn_play = false;
      this->btn_pause = false;
      this->btn_play_pause = false;
      this->btn_mode = false;
    }
  }

  explicit UserInputMedia_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->btn_vol_up = false;
      this->btn_vol_down = false;
      this->btn_mute = false;
      this->btn_next = false;
      this->btn_prev = false;
      this->btn_next_hang_up = false;
      this->btn_prev_answer = false;
      this->btn_hang_up = false;
      this->btn_answer = false;
      this->btn_play = false;
      this->btn_pause = false;
      this->btn_play_pause = false;
      this->btn_mode = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _btn_vol_up_type =
    bool;
  _btn_vol_up_type btn_vol_up;
  using _btn_vol_down_type =
    bool;
  _btn_vol_down_type btn_vol_down;
  using _btn_mute_type =
    bool;
  _btn_mute_type btn_mute;
  using _btn_next_type =
    bool;
  _btn_next_type btn_next;
  using _btn_prev_type =
    bool;
  _btn_prev_type btn_prev;
  using _btn_next_hang_up_type =
    bool;
  _btn_next_hang_up_type btn_next_hang_up;
  using _btn_prev_answer_type =
    bool;
  _btn_prev_answer_type btn_prev_answer;
  using _btn_hang_up_type =
    bool;
  _btn_hang_up_type btn_hang_up;
  using _btn_answer_type =
    bool;
  _btn_answer_type btn_answer;
  using _btn_play_type =
    bool;
  _btn_play_type btn_play;
  using _btn_pause_type =
    bool;
  _btn_pause_type btn_pause;
  using _btn_play_pause_type =
    bool;
  _btn_play_pause_type btn_play_pause;
  using _btn_mode_type =
    bool;
  _btn_mode_type btn_mode;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__btn_vol_up(
    const bool & _arg)
  {
    this->btn_vol_up = _arg;
    return *this;
  }
  Type & set__btn_vol_down(
    const bool & _arg)
  {
    this->btn_vol_down = _arg;
    return *this;
  }
  Type & set__btn_mute(
    const bool & _arg)
  {
    this->btn_mute = _arg;
    return *this;
  }
  Type & set__btn_next(
    const bool & _arg)
  {
    this->btn_next = _arg;
    return *this;
  }
  Type & set__btn_prev(
    const bool & _arg)
  {
    this->btn_prev = _arg;
    return *this;
  }
  Type & set__btn_next_hang_up(
    const bool & _arg)
  {
    this->btn_next_hang_up = _arg;
    return *this;
  }
  Type & set__btn_prev_answer(
    const bool & _arg)
  {
    this->btn_prev_answer = _arg;
    return *this;
  }
  Type & set__btn_hang_up(
    const bool & _arg)
  {
    this->btn_hang_up = _arg;
    return *this;
  }
  Type & set__btn_answer(
    const bool & _arg)
  {
    this->btn_answer = _arg;
    return *this;
  }
  Type & set__btn_play(
    const bool & _arg)
  {
    this->btn_play = _arg;
    return *this;
  }
  Type & set__btn_pause(
    const bool & _arg)
  {
    this->btn_pause = _arg;
    return *this;
  }
  Type & set__btn_play_pause(
    const bool & _arg)
  {
    this->btn_play_pause = _arg;
    return *this;
  }
  Type & set__btn_mode(
    const bool & _arg)
  {
    this->btn_mode = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_platform_msgs::msg::UserInputMedia_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_platform_msgs::msg::UserInputMedia_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::UserInputMedia_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::UserInputMedia_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::UserInputMedia_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::UserInputMedia_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::UserInputMedia_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::UserInputMedia_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::UserInputMedia_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::UserInputMedia_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_platform_msgs__msg__UserInputMedia
    std::shared_ptr<automotive_platform_msgs::msg::UserInputMedia_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_platform_msgs__msg__UserInputMedia
    std::shared_ptr<automotive_platform_msgs::msg::UserInputMedia_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const UserInputMedia_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->btn_vol_up != other.btn_vol_up) {
      return false;
    }
    if (this->btn_vol_down != other.btn_vol_down) {
      return false;
    }
    if (this->btn_mute != other.btn_mute) {
      return false;
    }
    if (this->btn_next != other.btn_next) {
      return false;
    }
    if (this->btn_prev != other.btn_prev) {
      return false;
    }
    if (this->btn_next_hang_up != other.btn_next_hang_up) {
      return false;
    }
    if (this->btn_prev_answer != other.btn_prev_answer) {
      return false;
    }
    if (this->btn_hang_up != other.btn_hang_up) {
      return false;
    }
    if (this->btn_answer != other.btn_answer) {
      return false;
    }
    if (this->btn_play != other.btn_play) {
      return false;
    }
    if (this->btn_pause != other.btn_pause) {
      return false;
    }
    if (this->btn_play_pause != other.btn_play_pause) {
      return false;
    }
    if (this->btn_mode != other.btn_mode) {
      return false;
    }
    return true;
  }
  bool operator!=(const UserInputMedia_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct UserInputMedia_

// alias to use template instance with default allocator
using UserInputMedia =
  automotive_platform_msgs::msg::UserInputMedia_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_platform_msgs

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__USER_INPUT_MEDIA__STRUCT_HPP_
