// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_platform_msgs:msg/CabinReport.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__CABIN_REPORT__STRUCT_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__CABIN_REPORT__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_platform_msgs__msg__CabinReport __attribute__((deprecated))
#else
# define DEPRECATED__automotive_platform_msgs__msg__CabinReport __declspec(deprecated)
#endif

namespace automotive_platform_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CabinReport_
{
  using Type = CabinReport_<ContainerAllocator>;

  explicit CabinReport_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->door_open_front_right = false;
      this->door_open_front_left = false;
      this->door_open_rear_right = false;
      this->door_open_rear_left = false;
      this->hood_open = false;
      this->trunk_open = false;
      this->passenger_present = false;
      this->passenger_airbag_enabled = false;
      this->seatbelt_engaged_driver = false;
      this->seatbelt_engaged_passenger = false;
    }
  }

  explicit CabinReport_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->door_open_front_right = false;
      this->door_open_front_left = false;
      this->door_open_rear_right = false;
      this->door_open_rear_left = false;
      this->hood_open = false;
      this->trunk_open = false;
      this->passenger_present = false;
      this->passenger_airbag_enabled = false;
      this->seatbelt_engaged_driver = false;
      this->seatbelt_engaged_passenger = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _door_open_front_right_type =
    bool;
  _door_open_front_right_type door_open_front_right;
  using _door_open_front_left_type =
    bool;
  _door_open_front_left_type door_open_front_left;
  using _door_open_rear_right_type =
    bool;
  _door_open_rear_right_type door_open_rear_right;
  using _door_open_rear_left_type =
    bool;
  _door_open_rear_left_type door_open_rear_left;
  using _hood_open_type =
    bool;
  _hood_open_type hood_open;
  using _trunk_open_type =
    bool;
  _trunk_open_type trunk_open;
  using _passenger_present_type =
    bool;
  _passenger_present_type passenger_present;
  using _passenger_airbag_enabled_type =
    bool;
  _passenger_airbag_enabled_type passenger_airbag_enabled;
  using _seatbelt_engaged_driver_type =
    bool;
  _seatbelt_engaged_driver_type seatbelt_engaged_driver;
  using _seatbelt_engaged_passenger_type =
    bool;
  _seatbelt_engaged_passenger_type seatbelt_engaged_passenger;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__door_open_front_right(
    const bool & _arg)
  {
    this->door_open_front_right = _arg;
    return *this;
  }
  Type & set__door_open_front_left(
    const bool & _arg)
  {
    this->door_open_front_left = _arg;
    return *this;
  }
  Type & set__door_open_rear_right(
    const bool & _arg)
  {
    this->door_open_rear_right = _arg;
    return *this;
  }
  Type & set__door_open_rear_left(
    const bool & _arg)
  {
    this->door_open_rear_left = _arg;
    return *this;
  }
  Type & set__hood_open(
    const bool & _arg)
  {
    this->hood_open = _arg;
    return *this;
  }
  Type & set__trunk_open(
    const bool & _arg)
  {
    this->trunk_open = _arg;
    return *this;
  }
  Type & set__passenger_present(
    const bool & _arg)
  {
    this->passenger_present = _arg;
    return *this;
  }
  Type & set__passenger_airbag_enabled(
    const bool & _arg)
  {
    this->passenger_airbag_enabled = _arg;
    return *this;
  }
  Type & set__seatbelt_engaged_driver(
    const bool & _arg)
  {
    this->seatbelt_engaged_driver = _arg;
    return *this;
  }
  Type & set__seatbelt_engaged_passenger(
    const bool & _arg)
  {
    this->seatbelt_engaged_passenger = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_platform_msgs::msg::CabinReport_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_platform_msgs::msg::CabinReport_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::CabinReport_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::CabinReport_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::CabinReport_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::CabinReport_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::CabinReport_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::CabinReport_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::CabinReport_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::CabinReport_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_platform_msgs__msg__CabinReport
    std::shared_ptr<automotive_platform_msgs::msg::CabinReport_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_platform_msgs__msg__CabinReport
    std::shared_ptr<automotive_platform_msgs::msg::CabinReport_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CabinReport_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->door_open_front_right != other.door_open_front_right) {
      return false;
    }
    if (this->door_open_front_left != other.door_open_front_left) {
      return false;
    }
    if (this->door_open_rear_right != other.door_open_rear_right) {
      return false;
    }
    if (this->door_open_rear_left != other.door_open_rear_left) {
      return false;
    }
    if (this->hood_open != other.hood_open) {
      return false;
    }
    if (this->trunk_open != other.trunk_open) {
      return false;
    }
    if (this->passenger_present != other.passenger_present) {
      return false;
    }
    if (this->passenger_airbag_enabled != other.passenger_airbag_enabled) {
      return false;
    }
    if (this->seatbelt_engaged_driver != other.seatbelt_engaged_driver) {
      return false;
    }
    if (this->seatbelt_engaged_passenger != other.seatbelt_engaged_passenger) {
      return false;
    }
    return true;
  }
  bool operator!=(const CabinReport_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CabinReport_

// alias to use template instance with default allocator
using CabinReport =
  automotive_platform_msgs::msg::CabinReport_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_platform_msgs

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__CABIN_REPORT__STRUCT_HPP_
