#ifndef _H_1E83376F467DFEDD4F6AB10E4C20AF77_AdaptiveCruiseControlCommand_DCPS_H_
#define _H_1E83376F467DFEDD4F6AB10E4C20AF77_AdaptiveCruiseControlCommand_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AdaptiveCruiseControlCommand_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class AdaptiveCruiseControlCommand_TypeSupportInterface;

            typedef AdaptiveCruiseControlCommand_TypeSupportInterface * AdaptiveCruiseControlCommand_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AdaptiveCruiseControlCommand_TypeSupportInterface> AdaptiveCruiseControlCommand_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AdaptiveCruiseControlCommand_TypeSupportInterface> AdaptiveCruiseControlCommand_TypeSupportInterface_out;


            class AdaptiveCruiseControlCommand_DataWriter;

            typedef AdaptiveCruiseControlCommand_DataWriter * AdaptiveCruiseControlCommand_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AdaptiveCruiseControlCommand_DataWriter> AdaptiveCruiseControlCommand_DataWriter_var;
            typedef DDS_DCPSInterface_out < AdaptiveCruiseControlCommand_DataWriter> AdaptiveCruiseControlCommand_DataWriter_out;


            class AdaptiveCruiseControlCommand_DataReader;

            typedef AdaptiveCruiseControlCommand_DataReader * AdaptiveCruiseControlCommand_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AdaptiveCruiseControlCommand_DataReader> AdaptiveCruiseControlCommand_DataReader_var;
            typedef DDS_DCPSInterface_out < AdaptiveCruiseControlCommand_DataReader> AdaptiveCruiseControlCommand_DataReader_out;


            class AdaptiveCruiseControlCommand_DataReaderView;

            typedef AdaptiveCruiseControlCommand_DataReaderView * AdaptiveCruiseControlCommand_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AdaptiveCruiseControlCommand_DataReaderView> AdaptiveCruiseControlCommand_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AdaptiveCruiseControlCommand_DataReaderView> AdaptiveCruiseControlCommand_DataReaderView_out;

            struct AdaptiveCruiseControlCommand_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AdaptiveCruiseControlCommand_, struct AdaptiveCruiseControlCommand_Seq_uniq_> AdaptiveCruiseControlCommand_Seq;
            typedef DDS_DCPSSequence_var < AdaptiveCruiseControlCommand_Seq> AdaptiveCruiseControlCommand_Seq_var;
            typedef DDS_DCPSSequence_out < AdaptiveCruiseControlCommand_Seq> AdaptiveCruiseControlCommand_Seq_out;

            class  AdaptiveCruiseControlCommand_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AdaptiveCruiseControlCommand_TypeSupportInterface_ptr _ptr_type;
                typedef AdaptiveCruiseControlCommand_TypeSupportInterface_var _var_type;

                static AdaptiveCruiseControlCommand_TypeSupportInterface_ptr _duplicate (AdaptiveCruiseControlCommand_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AdaptiveCruiseControlCommand_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlCommand_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlCommand_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AdaptiveCruiseControlCommand_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AdaptiveCruiseControlCommand_TypeSupportInterface () {};
                ~AdaptiveCruiseControlCommand_TypeSupportInterface () {};
            private:
                AdaptiveCruiseControlCommand_TypeSupportInterface (const AdaptiveCruiseControlCommand_TypeSupportInterface &);
                AdaptiveCruiseControlCommand_TypeSupportInterface & operator = (const AdaptiveCruiseControlCommand_TypeSupportInterface &);
            };

            class  AdaptiveCruiseControlCommand_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AdaptiveCruiseControlCommand_DataWriter_ptr _ptr_type;
                typedef AdaptiveCruiseControlCommand_DataWriter_var _var_type;

                static AdaptiveCruiseControlCommand_DataWriter_ptr _duplicate (AdaptiveCruiseControlCommand_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AdaptiveCruiseControlCommand_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlCommand_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlCommand_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AdaptiveCruiseControlCommand_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AdaptiveCruiseControlCommand_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AdaptiveCruiseControlCommand_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AdaptiveCruiseControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AdaptiveCruiseControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AdaptiveCruiseControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AdaptiveCruiseControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AdaptiveCruiseControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AdaptiveCruiseControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AdaptiveCruiseControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AdaptiveCruiseControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AdaptiveCruiseControlCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AdaptiveCruiseControlCommand_& instance_data) = 0;

            protected:
                AdaptiveCruiseControlCommand_DataWriter () {};
                ~AdaptiveCruiseControlCommand_DataWriter () {};
            private:
                AdaptiveCruiseControlCommand_DataWriter (const AdaptiveCruiseControlCommand_DataWriter &);
                AdaptiveCruiseControlCommand_DataWriter & operator = (const AdaptiveCruiseControlCommand_DataWriter &);
            };

            class  AdaptiveCruiseControlCommand_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AdaptiveCruiseControlCommand_DataReader_ptr _ptr_type;
                typedef AdaptiveCruiseControlCommand_DataReader_var _var_type;

                static AdaptiveCruiseControlCommand_DataReader_ptr _duplicate (AdaptiveCruiseControlCommand_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AdaptiveCruiseControlCommand_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlCommand_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlCommand_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AdaptiveCruiseControlCommand_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AdaptiveCruiseControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AdaptiveCruiseControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AdaptiveCruiseControlCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AdaptiveCruiseControlCommand_& instance) = 0;

            protected:
                AdaptiveCruiseControlCommand_DataReader () {};
                ~AdaptiveCruiseControlCommand_DataReader () {};
            private:
                AdaptiveCruiseControlCommand_DataReader (const AdaptiveCruiseControlCommand_DataReader &);
                AdaptiveCruiseControlCommand_DataReader & operator = (const AdaptiveCruiseControlCommand_DataReader &);
            };

            class  AdaptiveCruiseControlCommand_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AdaptiveCruiseControlCommand_DataReaderView_ptr _ptr_type;
                typedef AdaptiveCruiseControlCommand_DataReaderView_var _var_type;

                static AdaptiveCruiseControlCommand_DataReaderView_ptr _duplicate (AdaptiveCruiseControlCommand_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AdaptiveCruiseControlCommand_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlCommand_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AdaptiveCruiseControlCommand_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AdaptiveCruiseControlCommand_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AdaptiveCruiseControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AdaptiveCruiseControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AdaptiveCruiseControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AdaptiveCruiseControlCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AdaptiveCruiseControlCommand_& instance) = 0;

            protected:
                AdaptiveCruiseControlCommand_DataReaderView () {};
                ~AdaptiveCruiseControlCommand_DataReaderView () {};
            private:
                AdaptiveCruiseControlCommand_DataReaderView (const AdaptiveCruiseControlCommand_DataReaderView &);
                AdaptiveCruiseControlCommand_DataReaderView & operator = (const AdaptiveCruiseControlCommand_DataReaderView &);
            };
        }

    }

}

#endif
