#ifndef _H_2C6544EDCDC36AB59F4B4BDE3200E20A_BlindSpotIndicators_DCPS_H_
#define _H_2C6544EDCDC36AB59F4B4BDE3200E20A_BlindSpotIndicators_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "BlindSpotIndicators_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class BlindSpotIndicators_TypeSupportInterface;

            typedef BlindSpotIndicators_TypeSupportInterface * BlindSpotIndicators_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < BlindSpotIndicators_TypeSupportInterface> BlindSpotIndicators_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < BlindSpotIndicators_TypeSupportInterface> BlindSpotIndicators_TypeSupportInterface_out;


            class BlindSpotIndicators_DataWriter;

            typedef BlindSpotIndicators_DataWriter * BlindSpotIndicators_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < BlindSpotIndicators_DataWriter> BlindSpotIndicators_DataWriter_var;
            typedef DDS_DCPSInterface_out < BlindSpotIndicators_DataWriter> BlindSpotIndicators_DataWriter_out;


            class BlindSpotIndicators_DataReader;

            typedef BlindSpotIndicators_DataReader * BlindSpotIndicators_DataReader_ptr;
            typedef DDS_DCPSInterface_var < BlindSpotIndicators_DataReader> BlindSpotIndicators_DataReader_var;
            typedef DDS_DCPSInterface_out < BlindSpotIndicators_DataReader> BlindSpotIndicators_DataReader_out;


            class BlindSpotIndicators_DataReaderView;

            typedef BlindSpotIndicators_DataReaderView * BlindSpotIndicators_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < BlindSpotIndicators_DataReaderView> BlindSpotIndicators_DataReaderView_var;
            typedef DDS_DCPSInterface_out < BlindSpotIndicators_DataReaderView> BlindSpotIndicators_DataReaderView_out;

            struct BlindSpotIndicators_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < BlindSpotIndicators_, struct BlindSpotIndicators_Seq_uniq_> BlindSpotIndicators_Seq;
            typedef DDS_DCPSSequence_var < BlindSpotIndicators_Seq> BlindSpotIndicators_Seq_var;
            typedef DDS_DCPSSequence_out < BlindSpotIndicators_Seq> BlindSpotIndicators_Seq_out;

            class  BlindSpotIndicators_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef BlindSpotIndicators_TypeSupportInterface_ptr _ptr_type;
                typedef BlindSpotIndicators_TypeSupportInterface_var _var_type;

                static BlindSpotIndicators_TypeSupportInterface_ptr _duplicate (BlindSpotIndicators_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BlindSpotIndicators_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static BlindSpotIndicators_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BlindSpotIndicators_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                BlindSpotIndicators_TypeSupportInterface_ptr _this () { return this; }


            protected:
                BlindSpotIndicators_TypeSupportInterface () {};
                ~BlindSpotIndicators_TypeSupportInterface () {};
            private:
                BlindSpotIndicators_TypeSupportInterface (const BlindSpotIndicators_TypeSupportInterface &);
                BlindSpotIndicators_TypeSupportInterface & operator = (const BlindSpotIndicators_TypeSupportInterface &);
            };

            class  BlindSpotIndicators_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef BlindSpotIndicators_DataWriter_ptr _ptr_type;
                typedef BlindSpotIndicators_DataWriter_var _var_type;

                static BlindSpotIndicators_DataWriter_ptr _duplicate (BlindSpotIndicators_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BlindSpotIndicators_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static BlindSpotIndicators_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BlindSpotIndicators_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                BlindSpotIndicators_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const BlindSpotIndicators_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const BlindSpotIndicators_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const BlindSpotIndicators_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const BlindSpotIndicators_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const BlindSpotIndicators_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const BlindSpotIndicators_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const BlindSpotIndicators_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const BlindSpotIndicators_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const BlindSpotIndicators_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const BlindSpotIndicators_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (BlindSpotIndicators_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BlindSpotIndicators_& instance_data) = 0;

            protected:
                BlindSpotIndicators_DataWriter () {};
                ~BlindSpotIndicators_DataWriter () {};
            private:
                BlindSpotIndicators_DataWriter (const BlindSpotIndicators_DataWriter &);
                BlindSpotIndicators_DataWriter & operator = (const BlindSpotIndicators_DataWriter &);
            };

            class  BlindSpotIndicators_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef BlindSpotIndicators_DataReader_ptr _ptr_type;
                typedef BlindSpotIndicators_DataReader_var _var_type;

                static BlindSpotIndicators_DataReader_ptr _duplicate (BlindSpotIndicators_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BlindSpotIndicators_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static BlindSpotIndicators_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BlindSpotIndicators_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                BlindSpotIndicators_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BlindSpotIndicators_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BlindSpotIndicators_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BlindSpotIndicators_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BlindSpotIndicators_& instance) = 0;

            protected:
                BlindSpotIndicators_DataReader () {};
                ~BlindSpotIndicators_DataReader () {};
            private:
                BlindSpotIndicators_DataReader (const BlindSpotIndicators_DataReader &);
                BlindSpotIndicators_DataReader & operator = (const BlindSpotIndicators_DataReader &);
            };

            class  BlindSpotIndicators_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef BlindSpotIndicators_DataReaderView_ptr _ptr_type;
                typedef BlindSpotIndicators_DataReaderView_var _var_type;

                static BlindSpotIndicators_DataReaderView_ptr _duplicate (BlindSpotIndicators_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BlindSpotIndicators_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static BlindSpotIndicators_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BlindSpotIndicators_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                BlindSpotIndicators_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BlindSpotIndicators_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BlindSpotIndicators_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BlindSpotIndicators_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BlindSpotIndicators_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BlindSpotIndicators_& instance) = 0;

            protected:
                BlindSpotIndicators_DataReaderView () {};
                ~BlindSpotIndicators_DataReaderView () {};
            private:
                BlindSpotIndicators_DataReaderView (const BlindSpotIndicators_DataReaderView &);
                BlindSpotIndicators_DataReaderView & operator = (const BlindSpotIndicators_DataReaderView &);
            };
        }

    }

}

#endif
