#ifndef _H_A1D5B685D3594BCF7997B98BC3622A12_BrakeCommand_DCPS_H_
#define _H_A1D5B685D3594BCF7997B98BC3622A12_BrakeCommand_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "BrakeCommand_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class BrakeCommand_TypeSupportInterface;

            typedef BrakeCommand_TypeSupportInterface * BrakeCommand_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < BrakeCommand_TypeSupportInterface> BrakeCommand_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < BrakeCommand_TypeSupportInterface> BrakeCommand_TypeSupportInterface_out;


            class BrakeCommand_DataWriter;

            typedef BrakeCommand_DataWriter * BrakeCommand_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < BrakeCommand_DataWriter> BrakeCommand_DataWriter_var;
            typedef DDS_DCPSInterface_out < BrakeCommand_DataWriter> BrakeCommand_DataWriter_out;


            class BrakeCommand_DataReader;

            typedef BrakeCommand_DataReader * BrakeCommand_DataReader_ptr;
            typedef DDS_DCPSInterface_var < BrakeCommand_DataReader> BrakeCommand_DataReader_var;
            typedef DDS_DCPSInterface_out < BrakeCommand_DataReader> BrakeCommand_DataReader_out;


            class BrakeCommand_DataReaderView;

            typedef BrakeCommand_DataReaderView * BrakeCommand_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < BrakeCommand_DataReaderView> BrakeCommand_DataReaderView_var;
            typedef DDS_DCPSInterface_out < BrakeCommand_DataReaderView> BrakeCommand_DataReaderView_out;

            struct BrakeCommand_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < BrakeCommand_, struct BrakeCommand_Seq_uniq_> BrakeCommand_Seq;
            typedef DDS_DCPSSequence_var < BrakeCommand_Seq> BrakeCommand_Seq_var;
            typedef DDS_DCPSSequence_out < BrakeCommand_Seq> BrakeCommand_Seq_out;

            class  BrakeCommand_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef BrakeCommand_TypeSupportInterface_ptr _ptr_type;
                typedef BrakeCommand_TypeSupportInterface_var _var_type;

                static BrakeCommand_TypeSupportInterface_ptr _duplicate (BrakeCommand_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeCommand_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static BrakeCommand_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeCommand_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeCommand_TypeSupportInterface_ptr _this () { return this; }


            protected:
                BrakeCommand_TypeSupportInterface () {};
                ~BrakeCommand_TypeSupportInterface () {};
            private:
                BrakeCommand_TypeSupportInterface (const BrakeCommand_TypeSupportInterface &);
                BrakeCommand_TypeSupportInterface & operator = (const BrakeCommand_TypeSupportInterface &);
            };

            class  BrakeCommand_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef BrakeCommand_DataWriter_ptr _ptr_type;
                typedef BrakeCommand_DataWriter_var _var_type;

                static BrakeCommand_DataWriter_ptr _duplicate (BrakeCommand_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeCommand_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static BrakeCommand_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeCommand_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeCommand_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const BrakeCommand_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const BrakeCommand_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const BrakeCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const BrakeCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const BrakeCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const BrakeCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const BrakeCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const BrakeCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const BrakeCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const BrakeCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (BrakeCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BrakeCommand_& instance_data) = 0;

            protected:
                BrakeCommand_DataWriter () {};
                ~BrakeCommand_DataWriter () {};
            private:
                BrakeCommand_DataWriter (const BrakeCommand_DataWriter &);
                BrakeCommand_DataWriter & operator = (const BrakeCommand_DataWriter &);
            };

            class  BrakeCommand_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef BrakeCommand_DataReader_ptr _ptr_type;
                typedef BrakeCommand_DataReader_var _var_type;

                static BrakeCommand_DataReader_ptr _duplicate (BrakeCommand_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeCommand_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static BrakeCommand_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeCommand_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeCommand_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BrakeCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BrakeCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BrakeCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BrakeCommand_& instance) = 0;

            protected:
                BrakeCommand_DataReader () {};
                ~BrakeCommand_DataReader () {};
            private:
                BrakeCommand_DataReader (const BrakeCommand_DataReader &);
                BrakeCommand_DataReader & operator = (const BrakeCommand_DataReader &);
            };

            class  BrakeCommand_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef BrakeCommand_DataReaderView_ptr _ptr_type;
                typedef BrakeCommand_DataReaderView_var _var_type;

                static BrakeCommand_DataReaderView_ptr _duplicate (BrakeCommand_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeCommand_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static BrakeCommand_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeCommand_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeCommand_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BrakeCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BrakeCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BrakeCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BrakeCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BrakeCommand_& instance) = 0;

            protected:
                BrakeCommand_DataReaderView () {};
                ~BrakeCommand_DataReaderView () {};
            private:
                BrakeCommand_DataReaderView (const BrakeCommand_DataReaderView &);
                BrakeCommand_DataReaderView & operator = (const BrakeCommand_DataReaderView &);
            };
        }

    }

}

#endif
