#ifndef _H_CC2976405BCAF5AC12CD12BFA3EC382D_CurvatureFeedback_DCPS_H_
#define _H_CC2976405BCAF5AC12CD12BFA3EC382D_CurvatureFeedback_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CurvatureFeedback_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class CurvatureFeedback_TypeSupportInterface;

            typedef CurvatureFeedback_TypeSupportInterface * CurvatureFeedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CurvatureFeedback_TypeSupportInterface> CurvatureFeedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CurvatureFeedback_TypeSupportInterface> CurvatureFeedback_TypeSupportInterface_out;


            class CurvatureFeedback_DataWriter;

            typedef CurvatureFeedback_DataWriter * CurvatureFeedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CurvatureFeedback_DataWriter> CurvatureFeedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < CurvatureFeedback_DataWriter> CurvatureFeedback_DataWriter_out;


            class CurvatureFeedback_DataReader;

            typedef CurvatureFeedback_DataReader * CurvatureFeedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CurvatureFeedback_DataReader> CurvatureFeedback_DataReader_var;
            typedef DDS_DCPSInterface_out < CurvatureFeedback_DataReader> CurvatureFeedback_DataReader_out;


            class CurvatureFeedback_DataReaderView;

            typedef CurvatureFeedback_DataReaderView * CurvatureFeedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CurvatureFeedback_DataReaderView> CurvatureFeedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CurvatureFeedback_DataReaderView> CurvatureFeedback_DataReaderView_out;

            struct CurvatureFeedback_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < CurvatureFeedback_, struct CurvatureFeedback_Seq_uniq_> CurvatureFeedback_Seq;
            typedef DDS_DCPSSequence_var < CurvatureFeedback_Seq> CurvatureFeedback_Seq_var;
            typedef DDS_DCPSSequence_out < CurvatureFeedback_Seq> CurvatureFeedback_Seq_out;

            class  CurvatureFeedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CurvatureFeedback_TypeSupportInterface_ptr _ptr_type;
                typedef CurvatureFeedback_TypeSupportInterface_var _var_type;

                static CurvatureFeedback_TypeSupportInterface_ptr _duplicate (CurvatureFeedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CurvatureFeedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CurvatureFeedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CurvatureFeedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CurvatureFeedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CurvatureFeedback_TypeSupportInterface () {};
                ~CurvatureFeedback_TypeSupportInterface () {};
            private:
                CurvatureFeedback_TypeSupportInterface (const CurvatureFeedback_TypeSupportInterface &);
                CurvatureFeedback_TypeSupportInterface & operator = (const CurvatureFeedback_TypeSupportInterface &);
            };

            class  CurvatureFeedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CurvatureFeedback_DataWriter_ptr _ptr_type;
                typedef CurvatureFeedback_DataWriter_var _var_type;

                static CurvatureFeedback_DataWriter_ptr _duplicate (CurvatureFeedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CurvatureFeedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CurvatureFeedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CurvatureFeedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CurvatureFeedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CurvatureFeedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CurvatureFeedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CurvatureFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CurvatureFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CurvatureFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CurvatureFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CurvatureFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CurvatureFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CurvatureFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CurvatureFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CurvatureFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CurvatureFeedback_& instance_data) = 0;

            protected:
                CurvatureFeedback_DataWriter () {};
                ~CurvatureFeedback_DataWriter () {};
            private:
                CurvatureFeedback_DataWriter (const CurvatureFeedback_DataWriter &);
                CurvatureFeedback_DataWriter & operator = (const CurvatureFeedback_DataWriter &);
            };

            class  CurvatureFeedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CurvatureFeedback_DataReader_ptr _ptr_type;
                typedef CurvatureFeedback_DataReader_var _var_type;

                static CurvatureFeedback_DataReader_ptr _duplicate (CurvatureFeedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CurvatureFeedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CurvatureFeedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CurvatureFeedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CurvatureFeedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CurvatureFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CurvatureFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CurvatureFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CurvatureFeedback_& instance) = 0;

            protected:
                CurvatureFeedback_DataReader () {};
                ~CurvatureFeedback_DataReader () {};
            private:
                CurvatureFeedback_DataReader (const CurvatureFeedback_DataReader &);
                CurvatureFeedback_DataReader & operator = (const CurvatureFeedback_DataReader &);
            };

            class  CurvatureFeedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CurvatureFeedback_DataReaderView_ptr _ptr_type;
                typedef CurvatureFeedback_DataReaderView_var _var_type;

                static CurvatureFeedback_DataReaderView_ptr _duplicate (CurvatureFeedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CurvatureFeedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CurvatureFeedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CurvatureFeedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CurvatureFeedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CurvatureFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CurvatureFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CurvatureFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CurvatureFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CurvatureFeedback_& instance) = 0;

            protected:
                CurvatureFeedback_DataReaderView () {};
                ~CurvatureFeedback_DataReaderView () {};
            private:
                CurvatureFeedback_DataReaderView (const CurvatureFeedback_DataReaderView &);
                CurvatureFeedback_DataReaderView & operator = (const CurvatureFeedback_DataReaderView &);
            };
        }

    }

}

#endif
