#ifndef _H_8402B2DDF6E80C5B69204FFAF814A41A_HillStartAssist_DCPS_H_
#define _H_8402B2DDF6E80C5B69204FFAF814A41A_HillStartAssist_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "HillStartAssist_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class HillStartAssist_TypeSupportInterface;

            typedef HillStartAssist_TypeSupportInterface * HillStartAssist_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HillStartAssist_TypeSupportInterface> HillStartAssist_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HillStartAssist_TypeSupportInterface> HillStartAssist_TypeSupportInterface_out;


            class HillStartAssist_DataWriter;

            typedef HillStartAssist_DataWriter * HillStartAssist_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HillStartAssist_DataWriter> HillStartAssist_DataWriter_var;
            typedef DDS_DCPSInterface_out < HillStartAssist_DataWriter> HillStartAssist_DataWriter_out;


            class HillStartAssist_DataReader;

            typedef HillStartAssist_DataReader * HillStartAssist_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HillStartAssist_DataReader> HillStartAssist_DataReader_var;
            typedef DDS_DCPSInterface_out < HillStartAssist_DataReader> HillStartAssist_DataReader_out;


            class HillStartAssist_DataReaderView;

            typedef HillStartAssist_DataReaderView * HillStartAssist_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HillStartAssist_DataReaderView> HillStartAssist_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HillStartAssist_DataReaderView> HillStartAssist_DataReaderView_out;

            struct HillStartAssist_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < HillStartAssist_, struct HillStartAssist_Seq_uniq_> HillStartAssist_Seq;
            typedef DDS_DCPSSequence_var < HillStartAssist_Seq> HillStartAssist_Seq_var;
            typedef DDS_DCPSSequence_out < HillStartAssist_Seq> HillStartAssist_Seq_out;

            class  HillStartAssist_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HillStartAssist_TypeSupportInterface_ptr _ptr_type;
                typedef HillStartAssist_TypeSupportInterface_var _var_type;

                static HillStartAssist_TypeSupportInterface_ptr _duplicate (HillStartAssist_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HillStartAssist_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HillStartAssist_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HillStartAssist_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HillStartAssist_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HillStartAssist_TypeSupportInterface () {};
                ~HillStartAssist_TypeSupportInterface () {};
            private:
                HillStartAssist_TypeSupportInterface (const HillStartAssist_TypeSupportInterface &);
                HillStartAssist_TypeSupportInterface & operator = (const HillStartAssist_TypeSupportInterface &);
            };

            class  HillStartAssist_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HillStartAssist_DataWriter_ptr _ptr_type;
                typedef HillStartAssist_DataWriter_var _var_type;

                static HillStartAssist_DataWriter_ptr _duplicate (HillStartAssist_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HillStartAssist_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HillStartAssist_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HillStartAssist_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HillStartAssist_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HillStartAssist_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HillStartAssist_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HillStartAssist_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HillStartAssist_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HillStartAssist_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HillStartAssist_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HillStartAssist_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HillStartAssist_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HillStartAssist_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HillStartAssist_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HillStartAssist_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HillStartAssist_& instance_data) = 0;

            protected:
                HillStartAssist_DataWriter () {};
                ~HillStartAssist_DataWriter () {};
            private:
                HillStartAssist_DataWriter (const HillStartAssist_DataWriter &);
                HillStartAssist_DataWriter & operator = (const HillStartAssist_DataWriter &);
            };

            class  HillStartAssist_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HillStartAssist_DataReader_ptr _ptr_type;
                typedef HillStartAssist_DataReader_var _var_type;

                static HillStartAssist_DataReader_ptr _duplicate (HillStartAssist_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HillStartAssist_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HillStartAssist_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HillStartAssist_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HillStartAssist_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HillStartAssist_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HillStartAssist_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HillStartAssist_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HillStartAssist_& instance) = 0;

            protected:
                HillStartAssist_DataReader () {};
                ~HillStartAssist_DataReader () {};
            private:
                HillStartAssist_DataReader (const HillStartAssist_DataReader &);
                HillStartAssist_DataReader & operator = (const HillStartAssist_DataReader &);
            };

            class  HillStartAssist_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HillStartAssist_DataReaderView_ptr _ptr_type;
                typedef HillStartAssist_DataReaderView_var _var_type;

                static HillStartAssist_DataReaderView_ptr _duplicate (HillStartAssist_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HillStartAssist_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HillStartAssist_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HillStartAssist_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HillStartAssist_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HillStartAssist_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HillStartAssist_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HillStartAssist_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HillStartAssist_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HillStartAssist_& instance) = 0;

            protected:
                HillStartAssist_DataReaderView () {};
                ~HillStartAssist_DataReaderView () {};
            private:
                HillStartAssist_DataReaderView (const HillStartAssist_DataReaderView &);
                HillStartAssist_DataReaderView & operator = (const HillStartAssist_DataReaderView &);
            };
        }

    }

}

#endif
