#ifndef _H_9D4F04ED075849BAA986FD0AC5832CE7_SpeedMode__H_
#define _H_9D4F04ED075849BAA986FD0AC5832CE7_SpeedMode__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  SpeedMode_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::UShort mode_;
                ::DDS::Float speed_;
                ::DDS::Float acceleration_limit_;
                ::DDS::Float deceleration_limit_;
            };

            typedef DDS_DCPSStruct_var<SpeedMode_> SpeedMode__var;
            typedef DDS_DCPSStruct_out < SpeedMode_> SpeedMode__out;

        }

    }

}

#endif /* _H_9D4F04ED075849BAA986FD0AC5832CE7_SpeedMode__H_ */
