#ifndef _H_AE54F5A1F0AC38A4AF2B4D37549DDF8D_ThrottleCommand_DCPS_H_
#define _H_AE54F5A1F0AC38A4AF2B4D37549DDF8D_ThrottleCommand_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ThrottleCommand_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ThrottleCommand_TypeSupportInterface;

            typedef ThrottleCommand_TypeSupportInterface * ThrottleCommand_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ThrottleCommand_TypeSupportInterface> ThrottleCommand_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ThrottleCommand_TypeSupportInterface> ThrottleCommand_TypeSupportInterface_out;


            class ThrottleCommand_DataWriter;

            typedef ThrottleCommand_DataWriter * ThrottleCommand_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ThrottleCommand_DataWriter> ThrottleCommand_DataWriter_var;
            typedef DDS_DCPSInterface_out < ThrottleCommand_DataWriter> ThrottleCommand_DataWriter_out;


            class ThrottleCommand_DataReader;

            typedef ThrottleCommand_DataReader * ThrottleCommand_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ThrottleCommand_DataReader> ThrottleCommand_DataReader_var;
            typedef DDS_DCPSInterface_out < ThrottleCommand_DataReader> ThrottleCommand_DataReader_out;


            class ThrottleCommand_DataReaderView;

            typedef ThrottleCommand_DataReaderView * ThrottleCommand_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ThrottleCommand_DataReaderView> ThrottleCommand_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ThrottleCommand_DataReaderView> ThrottleCommand_DataReaderView_out;

            struct ThrottleCommand_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ThrottleCommand_, struct ThrottleCommand_Seq_uniq_> ThrottleCommand_Seq;
            typedef DDS_DCPSSequence_var < ThrottleCommand_Seq> ThrottleCommand_Seq_var;
            typedef DDS_DCPSSequence_out < ThrottleCommand_Seq> ThrottleCommand_Seq_out;

            class  ThrottleCommand_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ThrottleCommand_TypeSupportInterface_ptr _ptr_type;
                typedef ThrottleCommand_TypeSupportInterface_var _var_type;

                static ThrottleCommand_TypeSupportInterface_ptr _duplicate (ThrottleCommand_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ThrottleCommand_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ThrottleCommand_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ThrottleCommand_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ThrottleCommand_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ThrottleCommand_TypeSupportInterface () {};
                ~ThrottleCommand_TypeSupportInterface () {};
            private:
                ThrottleCommand_TypeSupportInterface (const ThrottleCommand_TypeSupportInterface &);
                ThrottleCommand_TypeSupportInterface & operator = (const ThrottleCommand_TypeSupportInterface &);
            };

            class  ThrottleCommand_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ThrottleCommand_DataWriter_ptr _ptr_type;
                typedef ThrottleCommand_DataWriter_var _var_type;

                static ThrottleCommand_DataWriter_ptr _duplicate (ThrottleCommand_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ThrottleCommand_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ThrottleCommand_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ThrottleCommand_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ThrottleCommand_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ThrottleCommand_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ThrottleCommand_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ThrottleCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ThrottleCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ThrottleCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ThrottleCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ThrottleCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ThrottleCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ThrottleCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ThrottleCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ThrottleCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ThrottleCommand_& instance_data) = 0;

            protected:
                ThrottleCommand_DataWriter () {};
                ~ThrottleCommand_DataWriter () {};
            private:
                ThrottleCommand_DataWriter (const ThrottleCommand_DataWriter &);
                ThrottleCommand_DataWriter & operator = (const ThrottleCommand_DataWriter &);
            };

            class  ThrottleCommand_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ThrottleCommand_DataReader_ptr _ptr_type;
                typedef ThrottleCommand_DataReader_var _var_type;

                static ThrottleCommand_DataReader_ptr _duplicate (ThrottleCommand_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ThrottleCommand_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ThrottleCommand_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ThrottleCommand_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ThrottleCommand_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ThrottleCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ThrottleCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ThrottleCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ThrottleCommand_& instance) = 0;

            protected:
                ThrottleCommand_DataReader () {};
                ~ThrottleCommand_DataReader () {};
            private:
                ThrottleCommand_DataReader (const ThrottleCommand_DataReader &);
                ThrottleCommand_DataReader & operator = (const ThrottleCommand_DataReader &);
            };

            class  ThrottleCommand_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ThrottleCommand_DataReaderView_ptr _ptr_type;
                typedef ThrottleCommand_DataReaderView_var _var_type;

                static ThrottleCommand_DataReaderView_ptr _duplicate (ThrottleCommand_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ThrottleCommand_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ThrottleCommand_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ThrottleCommand_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ThrottleCommand_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ThrottleCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ThrottleCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ThrottleCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ThrottleCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ThrottleCommand_& instance) = 0;

            protected:
                ThrottleCommand_DataReaderView () {};
                ~ThrottleCommand_DataReaderView () {};
            private:
                ThrottleCommand_DataReaderView (const ThrottleCommand_DataReaderView &);
                ThrottleCommand_DataReaderView & operator = (const ThrottleCommand_DataReaderView &);
            };
        }

    }

}

#endif
