#ifndef _H_F58C7212750F12F101E21171041B864E_ThrottleFeedback_DCPS_H_
#define _H_F58C7212750F12F101E21171041B864E_ThrottleFeedback_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ThrottleFeedback_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ThrottleFeedback_TypeSupportInterface;

            typedef ThrottleFeedback_TypeSupportInterface * ThrottleFeedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ThrottleFeedback_TypeSupportInterface> ThrottleFeedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ThrottleFeedback_TypeSupportInterface> ThrottleFeedback_TypeSupportInterface_out;


            class ThrottleFeedback_DataWriter;

            typedef ThrottleFeedback_DataWriter * ThrottleFeedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ThrottleFeedback_DataWriter> ThrottleFeedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < ThrottleFeedback_DataWriter> ThrottleFeedback_DataWriter_out;


            class ThrottleFeedback_DataReader;

            typedef ThrottleFeedback_DataReader * ThrottleFeedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ThrottleFeedback_DataReader> ThrottleFeedback_DataReader_var;
            typedef DDS_DCPSInterface_out < ThrottleFeedback_DataReader> ThrottleFeedback_DataReader_out;


            class ThrottleFeedback_DataReaderView;

            typedef ThrottleFeedback_DataReaderView * ThrottleFeedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ThrottleFeedback_DataReaderView> ThrottleFeedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ThrottleFeedback_DataReaderView> ThrottleFeedback_DataReaderView_out;

            struct ThrottleFeedback_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ThrottleFeedback_, struct ThrottleFeedback_Seq_uniq_> ThrottleFeedback_Seq;
            typedef DDS_DCPSSequence_var < ThrottleFeedback_Seq> ThrottleFeedback_Seq_var;
            typedef DDS_DCPSSequence_out < ThrottleFeedback_Seq> ThrottleFeedback_Seq_out;

            class  ThrottleFeedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ThrottleFeedback_TypeSupportInterface_ptr _ptr_type;
                typedef ThrottleFeedback_TypeSupportInterface_var _var_type;

                static ThrottleFeedback_TypeSupportInterface_ptr _duplicate (ThrottleFeedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ThrottleFeedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ThrottleFeedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ThrottleFeedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ThrottleFeedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ThrottleFeedback_TypeSupportInterface () {};
                ~ThrottleFeedback_TypeSupportInterface () {};
            private:
                ThrottleFeedback_TypeSupportInterface (const ThrottleFeedback_TypeSupportInterface &);
                ThrottleFeedback_TypeSupportInterface & operator = (const ThrottleFeedback_TypeSupportInterface &);
            };

            class  ThrottleFeedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ThrottleFeedback_DataWriter_ptr _ptr_type;
                typedef ThrottleFeedback_DataWriter_var _var_type;

                static ThrottleFeedback_DataWriter_ptr _duplicate (ThrottleFeedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ThrottleFeedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ThrottleFeedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ThrottleFeedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ThrottleFeedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ThrottleFeedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ThrottleFeedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ThrottleFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ThrottleFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ThrottleFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ThrottleFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ThrottleFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ThrottleFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ThrottleFeedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ThrottleFeedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ThrottleFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ThrottleFeedback_& instance_data) = 0;

            protected:
                ThrottleFeedback_DataWriter () {};
                ~ThrottleFeedback_DataWriter () {};
            private:
                ThrottleFeedback_DataWriter (const ThrottleFeedback_DataWriter &);
                ThrottleFeedback_DataWriter & operator = (const ThrottleFeedback_DataWriter &);
            };

            class  ThrottleFeedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ThrottleFeedback_DataReader_ptr _ptr_type;
                typedef ThrottleFeedback_DataReader_var _var_type;

                static ThrottleFeedback_DataReader_ptr _duplicate (ThrottleFeedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ThrottleFeedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ThrottleFeedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ThrottleFeedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ThrottleFeedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ThrottleFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ThrottleFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ThrottleFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ThrottleFeedback_& instance) = 0;

            protected:
                ThrottleFeedback_DataReader () {};
                ~ThrottleFeedback_DataReader () {};
            private:
                ThrottleFeedback_DataReader (const ThrottleFeedback_DataReader &);
                ThrottleFeedback_DataReader & operator = (const ThrottleFeedback_DataReader &);
            };

            class  ThrottleFeedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ThrottleFeedback_DataReaderView_ptr _ptr_type;
                typedef ThrottleFeedback_DataReaderView_var _var_type;

                static ThrottleFeedback_DataReaderView_ptr _duplicate (ThrottleFeedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ThrottleFeedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ThrottleFeedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ThrottleFeedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ThrottleFeedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ThrottleFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ThrottleFeedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ThrottleFeedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ThrottleFeedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ThrottleFeedback_& instance) = 0;

            protected:
                ThrottleFeedback_DataReaderView () {};
                ~ThrottleFeedback_DataReaderView () {};
            private:
                ThrottleFeedback_DataReaderView (const ThrottleFeedback_DataReaderView &);
                ThrottleFeedback_DataReaderView & operator = (const ThrottleFeedback_DataReaderView &);
            };
        }

    }

}

#endif
