#ifndef _H_0E3DB84EB49DEC08C11557F389C76304_TurnSignalCommand__H_
#define _H_0E3DB84EB49DEC08C11557F389C76304_TurnSignalCommand__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace TurnSignalCommand_Constants
            {
                const ::DDS::Octet NONE_ = 0;

                const ::DDS::Octet LEFT_ = 1;

                const ::DDS::Octet RIGHT_ = 2;

            }

            struct  TurnSignalCommand_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::UShort mode_;
                ::DDS::Octet turn_signal_;
            };

            typedef DDS_DCPSStruct_var<TurnSignalCommand_> TurnSignalCommand__var;
            typedef DDS_DCPSStruct_out < TurnSignalCommand_> TurnSignalCommand__out;

        }

    }

}

#endif /* _H_0E3DB84EB49DEC08C11557F389C76304_TurnSignalCommand__H_ */
