#ifndef _H_F0A20B2F66B23490A6C16F0DA5B49311_UserInputADAS__H_
#define _H_F0A20B2F66B23490A6C16F0DA5B49311_UserInputADAS__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  UserInputADAS_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean btn_cc_on_;
                ::DDS::Boolean btn_cc_off_;
                ::DDS::Boolean btn_cc_on_off_;
                ::DDS::Boolean btn_cc_set_inc_;
                ::DDS::Boolean btn_cc_set_dec_;
                ::DDS::Boolean btn_cc_res_;
                ::DDS::Boolean btn_cc_cncl_;
                ::DDS::Boolean btn_cc_res_cncl_;
                ::DDS::Boolean btn_acc_gap_inc_;
                ::DDS::Boolean btn_acc_gap_dec_;
                ::DDS::Boolean btn_lka_on_;
                ::DDS::Boolean btn_lka_off_;
                ::DDS::Boolean btn_lka_on_off_;
            };

            typedef DDS_DCPSStruct_var<UserInputADAS_> UserInputADAS__var;
            typedef DDS_DCPSStruct_out < UserInputADAS_> UserInputADAS__out;

        }

    }

}

#endif /* _H_F0A20B2F66B23490A6C16F0DA5B49311_UserInputADAS__H_ */
