#ifndef _H_038C0EDD09B75B440CE2B2135B4EEA72_UserInputMedia__H_
#define _H_038C0EDD09B75B440CE2B2135B4EEA72_UserInputMedia__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  UserInputMedia_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean btn_vol_up_;
                ::DDS::Boolean btn_vol_down_;
                ::DDS::Boolean btn_mute_;
                ::DDS::Boolean btn_next_;
                ::DDS::Boolean btn_prev_;
                ::DDS::Boolean btn_next_hang_up_;
                ::DDS::Boolean btn_prev_answer_;
                ::DDS::Boolean btn_hang_up_;
                ::DDS::Boolean btn_answer_;
                ::DDS::Boolean btn_play_;
                ::DDS::Boolean btn_pause_;
                ::DDS::Boolean btn_play_pause_;
                ::DDS::Boolean btn_mode_;
            };

            typedef DDS_DCPSStruct_var<UserInputMedia_> UserInputMedia__var;
            typedef DDS_DCPSStruct_out < UserInputMedia_> UserInputMedia__out;

        }

    }

}

#endif /* _H_038C0EDD09B75B440CE2B2135B4EEA72_UserInputMedia__H_ */
