#ifndef _H_0930AF17F1EA77163656A32EA24CCC3B_VelocityAccelCov_DCPS_H_
#define _H_0930AF17F1EA77163656A32EA24CCC3B_VelocityAccelCov_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VelocityAccelCov_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VelocityAccelCov_TypeSupportInterface;

            typedef VelocityAccelCov_TypeSupportInterface * VelocityAccelCov_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VelocityAccelCov_TypeSupportInterface> VelocityAccelCov_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VelocityAccelCov_TypeSupportInterface> VelocityAccelCov_TypeSupportInterface_out;


            class VelocityAccelCov_DataWriter;

            typedef VelocityAccelCov_DataWriter * VelocityAccelCov_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VelocityAccelCov_DataWriter> VelocityAccelCov_DataWriter_var;
            typedef DDS_DCPSInterface_out < VelocityAccelCov_DataWriter> VelocityAccelCov_DataWriter_out;


            class VelocityAccelCov_DataReader;

            typedef VelocityAccelCov_DataReader * VelocityAccelCov_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VelocityAccelCov_DataReader> VelocityAccelCov_DataReader_var;
            typedef DDS_DCPSInterface_out < VelocityAccelCov_DataReader> VelocityAccelCov_DataReader_out;


            class VelocityAccelCov_DataReaderView;

            typedef VelocityAccelCov_DataReaderView * VelocityAccelCov_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VelocityAccelCov_DataReaderView> VelocityAccelCov_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VelocityAccelCov_DataReaderView> VelocityAccelCov_DataReaderView_out;

            struct VelocityAccelCov_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < VelocityAccelCov_, struct VelocityAccelCov_Seq_uniq_> VelocityAccelCov_Seq;
            typedef DDS_DCPSSequence_var < VelocityAccelCov_Seq> VelocityAccelCov_Seq_var;
            typedef DDS_DCPSSequence_out < VelocityAccelCov_Seq> VelocityAccelCov_Seq_out;

            class  VelocityAccelCov_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VelocityAccelCov_TypeSupportInterface_ptr _ptr_type;
                typedef VelocityAccelCov_TypeSupportInterface_var _var_type;

                static VelocityAccelCov_TypeSupportInterface_ptr _duplicate (VelocityAccelCov_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VelocityAccelCov_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VelocityAccelCov_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VelocityAccelCov_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VelocityAccelCov_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VelocityAccelCov_TypeSupportInterface () {};
                ~VelocityAccelCov_TypeSupportInterface () {};
            private:
                VelocityAccelCov_TypeSupportInterface (const VelocityAccelCov_TypeSupportInterface &);
                VelocityAccelCov_TypeSupportInterface & operator = (const VelocityAccelCov_TypeSupportInterface &);
            };

            class  VelocityAccelCov_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VelocityAccelCov_DataWriter_ptr _ptr_type;
                typedef VelocityAccelCov_DataWriter_var _var_type;

                static VelocityAccelCov_DataWriter_ptr _duplicate (VelocityAccelCov_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VelocityAccelCov_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VelocityAccelCov_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VelocityAccelCov_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VelocityAccelCov_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VelocityAccelCov_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VelocityAccelCov_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VelocityAccelCov_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VelocityAccelCov_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VelocityAccelCov_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VelocityAccelCov_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VelocityAccelCov_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VelocityAccelCov_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VelocityAccelCov_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VelocityAccelCov_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VelocityAccelCov_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VelocityAccelCov_& instance_data) = 0;

            protected:
                VelocityAccelCov_DataWriter () {};
                ~VelocityAccelCov_DataWriter () {};
            private:
                VelocityAccelCov_DataWriter (const VelocityAccelCov_DataWriter &);
                VelocityAccelCov_DataWriter & operator = (const VelocityAccelCov_DataWriter &);
            };

            class  VelocityAccelCov_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VelocityAccelCov_DataReader_ptr _ptr_type;
                typedef VelocityAccelCov_DataReader_var _var_type;

                static VelocityAccelCov_DataReader_ptr _duplicate (VelocityAccelCov_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VelocityAccelCov_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VelocityAccelCov_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VelocityAccelCov_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VelocityAccelCov_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VelocityAccelCov_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VelocityAccelCov_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VelocityAccelCov_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VelocityAccelCov_& instance) = 0;

            protected:
                VelocityAccelCov_DataReader () {};
                ~VelocityAccelCov_DataReader () {};
            private:
                VelocityAccelCov_DataReader (const VelocityAccelCov_DataReader &);
                VelocityAccelCov_DataReader & operator = (const VelocityAccelCov_DataReader &);
            };

            class  VelocityAccelCov_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VelocityAccelCov_DataReaderView_ptr _ptr_type;
                typedef VelocityAccelCov_DataReaderView_var _var_type;

                static VelocityAccelCov_DataReaderView_ptr _duplicate (VelocityAccelCov_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VelocityAccelCov_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VelocityAccelCov_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VelocityAccelCov_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VelocityAccelCov_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VelocityAccelCov_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VelocityAccelCov_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VelocityAccelCov_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VelocityAccelCov_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VelocityAccelCov_& instance) = 0;

            protected:
                VelocityAccelCov_DataReaderView () {};
                ~VelocityAccelCov_DataReaderView () {};
            private:
                VelocityAccelCov_DataReaderView (const VelocityAccelCov_DataReaderView &);
                VelocityAccelCov_DataReaderView & operator = (const VelocityAccelCov_DataReaderView &);
            };
        }

    }

}

#endif
