#ifndef _H_E6A71B8B648DFF454E3D4C5026A235BD_VelocityAccel_DCPS_H_
#define _H_E6A71B8B648DFF454E3D4C5026A235BD_VelocityAccel_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VelocityAccel_.h"


namespace automotive_platform_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VelocityAccel_TypeSupportInterface;

            typedef VelocityAccel_TypeSupportInterface * VelocityAccel_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VelocityAccel_TypeSupportInterface> VelocityAccel_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VelocityAccel_TypeSupportInterface> VelocityAccel_TypeSupportInterface_out;


            class VelocityAccel_DataWriter;

            typedef VelocityAccel_DataWriter * VelocityAccel_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VelocityAccel_DataWriter> VelocityAccel_DataWriter_var;
            typedef DDS_DCPSInterface_out < VelocityAccel_DataWriter> VelocityAccel_DataWriter_out;


            class VelocityAccel_DataReader;

            typedef VelocityAccel_DataReader * VelocityAccel_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VelocityAccel_DataReader> VelocityAccel_DataReader_var;
            typedef DDS_DCPSInterface_out < VelocityAccel_DataReader> VelocityAccel_DataReader_out;


            class VelocityAccel_DataReaderView;

            typedef VelocityAccel_DataReaderView * VelocityAccel_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VelocityAccel_DataReaderView> VelocityAccel_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VelocityAccel_DataReaderView> VelocityAccel_DataReaderView_out;

            struct VelocityAccel_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < VelocityAccel_, struct VelocityAccel_Seq_uniq_> VelocityAccel_Seq;
            typedef DDS_DCPSSequence_var < VelocityAccel_Seq> VelocityAccel_Seq_var;
            typedef DDS_DCPSSequence_out < VelocityAccel_Seq> VelocityAccel_Seq_out;

            class  VelocityAccel_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VelocityAccel_TypeSupportInterface_ptr _ptr_type;
                typedef VelocityAccel_TypeSupportInterface_var _var_type;

                static VelocityAccel_TypeSupportInterface_ptr _duplicate (VelocityAccel_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VelocityAccel_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VelocityAccel_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VelocityAccel_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VelocityAccel_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VelocityAccel_TypeSupportInterface () {};
                ~VelocityAccel_TypeSupportInterface () {};
            private:
                VelocityAccel_TypeSupportInterface (const VelocityAccel_TypeSupportInterface &);
                VelocityAccel_TypeSupportInterface & operator = (const VelocityAccel_TypeSupportInterface &);
            };

            class  VelocityAccel_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VelocityAccel_DataWriter_ptr _ptr_type;
                typedef VelocityAccel_DataWriter_var _var_type;

                static VelocityAccel_DataWriter_ptr _duplicate (VelocityAccel_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VelocityAccel_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VelocityAccel_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VelocityAccel_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VelocityAccel_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VelocityAccel_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VelocityAccel_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VelocityAccel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VelocityAccel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VelocityAccel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VelocityAccel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VelocityAccel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VelocityAccel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VelocityAccel_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VelocityAccel_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VelocityAccel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VelocityAccel_& instance_data) = 0;

            protected:
                VelocityAccel_DataWriter () {};
                ~VelocityAccel_DataWriter () {};
            private:
                VelocityAccel_DataWriter (const VelocityAccel_DataWriter &);
                VelocityAccel_DataWriter & operator = (const VelocityAccel_DataWriter &);
            };

            class  VelocityAccel_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VelocityAccel_DataReader_ptr _ptr_type;
                typedef VelocityAccel_DataReader_var _var_type;

                static VelocityAccel_DataReader_ptr _duplicate (VelocityAccel_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VelocityAccel_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VelocityAccel_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VelocityAccel_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VelocityAccel_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VelocityAccel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VelocityAccel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VelocityAccel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VelocityAccel_& instance) = 0;

            protected:
                VelocityAccel_DataReader () {};
                ~VelocityAccel_DataReader () {};
            private:
                VelocityAccel_DataReader (const VelocityAccel_DataReader &);
                VelocityAccel_DataReader & operator = (const VelocityAccel_DataReader &);
            };

            class  VelocityAccel_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VelocityAccel_DataReaderView_ptr _ptr_type;
                typedef VelocityAccel_DataReaderView_var _var_type;

                static VelocityAccel_DataReaderView_ptr _duplicate (VelocityAccel_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VelocityAccel_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VelocityAccel_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VelocityAccel_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VelocityAccel_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VelocityAccel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VelocityAccel_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VelocityAccel_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VelocityAccel_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VelocityAccel_& instance) = 0;

            protected:
                VelocityAccel_DataReaderView () {};
                ~VelocityAccel_DataReaderView () {};
            private:
                VelocityAccel_DataReaderView (const VelocityAccel_DataReaderView &);
                VelocityAccel_DataReaderView & operator = (const VelocityAccel_DataReaderView &);
            };
        }

    }

}

#endif
