// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_platform_msgs:msg/DriverCommands.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__DRIVER_COMMANDS__STRUCT_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__DRIVER_COMMANDS__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__automotive_platform_msgs__msg__DriverCommands __attribute__((deprecated))
#else
# define DEPRECATED__automotive_platform_msgs__msg__DriverCommands __declspec(deprecated)
#endif

namespace automotive_platform_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DriverCommands_
{
  using Type = DriverCommands_<ContainerAllocator>;

  explicit DriverCommands_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->msg_counter = 0;
      this->engage = 0;
      this->disengage = 0;
      this->speed_up = 0;
      this->slow_down = 0;
      this->further = 0;
      this->closer = 0;
      this->right_turn = 0;
      this->left_turn = 0;
    }
  }

  explicit DriverCommands_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->msg_counter = 0;
      this->engage = 0;
      this->disengage = 0;
      this->speed_up = 0;
      this->slow_down = 0;
      this->further = 0;
      this->closer = 0;
      this->right_turn = 0;
      this->left_turn = 0;
    }
  }

  // field types and members
  using _msg_counter_type =
    uint8_t;
  _msg_counter_type msg_counter;
  using _engage_type =
    uint16_t;
  _engage_type engage;
  using _disengage_type =
    uint16_t;
  _disengage_type disengage;
  using _speed_up_type =
    uint16_t;
  _speed_up_type speed_up;
  using _slow_down_type =
    uint16_t;
  _slow_down_type slow_down;
  using _further_type =
    uint16_t;
  _further_type further;
  using _closer_type =
    uint16_t;
  _closer_type closer;
  using _right_turn_type =
    uint16_t;
  _right_turn_type right_turn;
  using _left_turn_type =
    uint16_t;
  _left_turn_type left_turn;

  // setters for named parameter idiom
  Type & set__msg_counter(
    const uint8_t & _arg)
  {
    this->msg_counter = _arg;
    return *this;
  }
  Type & set__engage(
    const uint16_t & _arg)
  {
    this->engage = _arg;
    return *this;
  }
  Type & set__disengage(
    const uint16_t & _arg)
  {
    this->disengage = _arg;
    return *this;
  }
  Type & set__speed_up(
    const uint16_t & _arg)
  {
    this->speed_up = _arg;
    return *this;
  }
  Type & set__slow_down(
    const uint16_t & _arg)
  {
    this->slow_down = _arg;
    return *this;
  }
  Type & set__further(
    const uint16_t & _arg)
  {
    this->further = _arg;
    return *this;
  }
  Type & set__closer(
    const uint16_t & _arg)
  {
    this->closer = _arg;
    return *this;
  }
  Type & set__right_turn(
    const uint16_t & _arg)
  {
    this->right_turn = _arg;
    return *this;
  }
  Type & set__left_turn(
    const uint16_t & _arg)
  {
    this->left_turn = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_platform_msgs::msg::DriverCommands_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_platform_msgs::msg::DriverCommands_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::DriverCommands_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::DriverCommands_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::DriverCommands_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::DriverCommands_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::DriverCommands_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::DriverCommands_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::DriverCommands_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::DriverCommands_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_platform_msgs__msg__DriverCommands
    std::shared_ptr<automotive_platform_msgs::msg::DriverCommands_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_platform_msgs__msg__DriverCommands
    std::shared_ptr<automotive_platform_msgs::msg::DriverCommands_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DriverCommands_ & other) const
  {
    if (this->msg_counter != other.msg_counter) {
      return false;
    }
    if (this->engage != other.engage) {
      return false;
    }
    if (this->disengage != other.disengage) {
      return false;
    }
    if (this->speed_up != other.speed_up) {
      return false;
    }
    if (this->slow_down != other.slow_down) {
      return false;
    }
    if (this->further != other.further) {
      return false;
    }
    if (this->closer != other.closer) {
      return false;
    }
    if (this->right_turn != other.right_turn) {
      return false;
    }
    if (this->left_turn != other.left_turn) {
      return false;
    }
    return true;
  }
  bool operator!=(const DriverCommands_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DriverCommands_

// alias to use template instance with default allocator
using DriverCommands =
  automotive_platform_msgs::msg::DriverCommands_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_platform_msgs

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__DRIVER_COMMANDS__STRUCT_HPP_
