// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_platform_msgs:msg/TurnSignalCommand.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__TURN_SIGNAL_COMMAND__STRUCT_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__TURN_SIGNAL_COMMAND__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_platform_msgs__msg__TurnSignalCommand __attribute__((deprecated))
#else
# define DEPRECATED__automotive_platform_msgs__msg__TurnSignalCommand __declspec(deprecated)
#endif

namespace automotive_platform_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TurnSignalCommand_
{
  using Type = TurnSignalCommand_<ContainerAllocator>;

  explicit TurnSignalCommand_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->mode = 0;
      this->turn_signal = 0;
    }
  }

  explicit TurnSignalCommand_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->mode = 0;
      this->turn_signal = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _mode_type =
    uint16_t;
  _mode_type mode;
  using _turn_signal_type =
    uint8_t;
  _turn_signal_type turn_signal;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__mode(
    const uint16_t & _arg)
  {
    this->mode = _arg;
    return *this;
  }
  Type & set__turn_signal(
    const uint8_t & _arg)
  {
    this->turn_signal = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t NONE =
    0u;
  static constexpr uint8_t LEFT =
    1u;
  static constexpr uint8_t RIGHT =
    2u;

  // pointer types
  using RawPtr =
    automotive_platform_msgs::msg::TurnSignalCommand_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_platform_msgs::msg::TurnSignalCommand_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::TurnSignalCommand_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::TurnSignalCommand_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::TurnSignalCommand_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::TurnSignalCommand_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::TurnSignalCommand_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::TurnSignalCommand_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::TurnSignalCommand_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::TurnSignalCommand_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_platform_msgs__msg__TurnSignalCommand
    std::shared_ptr<automotive_platform_msgs::msg::TurnSignalCommand_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_platform_msgs__msg__TurnSignalCommand
    std::shared_ptr<automotive_platform_msgs::msg::TurnSignalCommand_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TurnSignalCommand_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->mode != other.mode) {
      return false;
    }
    if (this->turn_signal != other.turn_signal) {
      return false;
    }
    return true;
  }
  bool operator!=(const TurnSignalCommand_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TurnSignalCommand_

// alias to use template instance with default allocator
using TurnSignalCommand =
  automotive_platform_msgs::msg::TurnSignalCommand_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t TurnSignalCommand_<ContainerAllocator>::NONE;
template<typename ContainerAllocator>
constexpr uint8_t TurnSignalCommand_<ContainerAllocator>::LEFT;
template<typename ContainerAllocator>
constexpr uint8_t TurnSignalCommand_<ContainerAllocator>::RIGHT;

}  // namespace msg

}  // namespace automotive_platform_msgs

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__TURN_SIGNAL_COMMAND__STRUCT_HPP_
