// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_platform_msgs:msg/VelocityAccelCov.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__VELOCITY_ACCEL_COV__STRUCT_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__VELOCITY_ACCEL_COV__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_platform_msgs__msg__VelocityAccelCov __attribute__((deprecated))
#else
# define DEPRECATED__automotive_platform_msgs__msg__VelocityAccelCov __declspec(deprecated)
#endif

namespace automotive_platform_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VelocityAccelCov_
{
  using Type = VelocityAccelCov_<ContainerAllocator>;

  explicit VelocityAccelCov_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->velocity = 0.0f;
      this->accleration = 0.0f;
      this->covariance = 0.0f;
    }
  }

  explicit VelocityAccelCov_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->velocity = 0.0f;
      this->accleration = 0.0f;
      this->covariance = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _velocity_type =
    float;
  _velocity_type velocity;
  using _accleration_type =
    float;
  _accleration_type accleration;
  using _covariance_type =
    float;
  _covariance_type covariance;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__velocity(
    const float & _arg)
  {
    this->velocity = _arg;
    return *this;
  }
  Type & set__accleration(
    const float & _arg)
  {
    this->accleration = _arg;
    return *this;
  }
  Type & set__covariance(
    const float & _arg)
  {
    this->covariance = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_platform_msgs::msg::VelocityAccelCov_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_platform_msgs::msg::VelocityAccelCov_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::VelocityAccelCov_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_platform_msgs::msg::VelocityAccelCov_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::VelocityAccelCov_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::VelocityAccelCov_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_platform_msgs::msg::VelocityAccelCov_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_platform_msgs::msg::VelocityAccelCov_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::VelocityAccelCov_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_platform_msgs::msg::VelocityAccelCov_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_platform_msgs__msg__VelocityAccelCov
    std::shared_ptr<automotive_platform_msgs::msg::VelocityAccelCov_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_platform_msgs__msg__VelocityAccelCov
    std::shared_ptr<automotive_platform_msgs::msg::VelocityAccelCov_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VelocityAccelCov_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->velocity != other.velocity) {
      return false;
    }
    if (this->accleration != other.accleration) {
      return false;
    }
    if (this->covariance != other.covariance) {
      return false;
    }
    return true;
  }
  bool operator!=(const VelocityAccelCov_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VelocityAccelCov_

// alias to use template instance with default allocator
using VelocityAccelCov =
  automotive_platform_msgs::msg::VelocityAccelCov_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_platform_msgs

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__VELOCITY_ACCEL_COV__STRUCT_HPP_
